IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfBankAccountCreate'
		DROP PROCEDURE [dbo].[adfBankAccountCreate]
	END
GO

PRINT 'Creating procedure adfBankAccountCreate'
GO

/******************************************************************************
**		File: adfBankAccountCreate.sql
**		Name: adfBankAccountCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 15:04:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfBankAccountCreate]
	@CompanyID TIdentifier,
	@FileAs TName,
	@CurrencyCode TCode3,
	@BankName TName,
	@BankCode TCode,
	@Country TName,
	@City TCity,
	@Address TName,
	@SWIFT TCode,
	@ABA TCode,
	@IBAN TCode,
	@Account TAccount,
	@IntermediaryBank TName,
	@IntermediaryAddress TName,
	@IntermediarySWIFT TCode,
	@IntermediaryABA TCode,
	@IntermediaryAccount TAccount,
	@AdditionalAccounts TDescription
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('8c7d72e2-6036-4c5b-aa76-85e8114fe212')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @CurrencyCode IS NULL
	BEGIN
		RAISERROR('#currencycodeismandatory', 18, -1)
		RETURN 1
	END

	INSERT INTO [BankAccount]
		([Flag], [State], [CompanyID], [FileAs], [CurrencyCode], [BankName], [BankCode], [Country], [City], [Address],
		[SWIFT], [ABA], [IBAN],	[Account], 
		[IntermediaryBank], [IntermediaryAddress], [IntermediarySWIFT], [IntermediaryABA], [IntermediaryAccount], 
		[AdditionalAccounts])
	VALUES
		(0, @State, @CompanyID, @FileAs, @CurrencyCode, @BankName, @BankCode, @Country, @City, @Address,
		@SWIFT, @ABA, @IBAN, @Account, 
		@IntermediaryBank, @IntermediaryAddress, @IntermediarySWIFT, @IntermediaryABA, @IntermediaryAccount, 
		@AdditionalAccounts)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	IF (SELECT
			[Company].[BankAccountID]
		FROM
			[Company]
		WHERE
			[Company].[ID] = @CompanyID) IS NULL
	BEGIN
		UPDATE
			[Company]
		SET
			[Company].[BankAccountID] = @ID
		WHERE
			[Company].[ID] = @CompanyID
	END

	EXEC adfBankAccountGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfBankAccountCreate TO PUBLIC
GO
 