IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentCategoryCopy')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentCategoryCopy'
		DROP  Procedure  adfDocumentCategoryCopy
	END

GO

PRINT 'Creating Procedure adfDocumentCategoryCopy'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentCategoryCopy
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentCategoryCopy
	@DocumentClass TClass,
	@SourceDocumentID TIdentifier,
	@DestDocumentID TIdentifier
AS
	SET NOCOUNT ON
	INSERT INTO [DocumentCategory] ([DocumentClass], [DocumentID], [CategoryID])
	SELECT
		@DocumentClass,
		@DestDocumentID,
		[DocumentCategory].[CategoryID]
	FROM
		[DocumentCategory]
	WHERE
		[DocumentCategory].[DocumentClass] = @DocumentClass AND
		[DocumentCategory].[DocumentID] = @SourceDocumentID
		
	IF @@error != 0
		RETURN 1
		
	RETURN 0
GO

GRANT EXEC ON adfDocumentCategoryCopy TO PUBLIC
GO
