IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentContactBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentContactBrowse'
		DROP  Procedure  adfDocumentContactBrowse
	END

GO

PRINT 'Creating Procedure adfDocumentContactBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentContactBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentContactBrowse
	@DocumentID TIdentifier,
	@DocumentClass TClass
AS
	SET NOCOUNT ON

	SELECT
		[BusinessCard].[ID],
		[BusinessCard].[Class],
		[BusinessCard].[State],
		[BusinessCard].[FileAs],
		[BusinessCard].[Created],
		[BusinessCard].[CreatedBy],
		[BusinessCard].[Modified],
		[BusinessCard].[ModifiedBy],
		[BusinessCard].[Timestamp]
	FROM
		[DocumentContact] INNER JOIN [BusinessCard]
			ON ([DocumentContact].[BusinessCardClass] = [BusinessCard].[Class]
				AND [DocumentContact].[BusinessCardID] = [BusinessCard].[ID])
	WHERE
		[DocumentContact].[DocumentID] = @DocumentID
	AND
		[DocumentContact].[DocumentClass] = @DocumentClass

	RETURN 0
GO

GRANT EXEC ON adfDocumentContactBrowse TO PUBLIC
GO
