IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemChangeState'
		DROP PROCEDURE [dbo].[adfMailItemChangeState]
	END
GO

PRINT 'Creating procedure adfMailItemChangeState'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemChangeState.sql
**		Name: adfMailItemChangeState
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/17/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfMailItemChangeState] @ID TIdentifier, @State TState
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()

	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Adf.MailItem')

	DECLARE @Read TBool
	
	SELECT
		@Read = CAST(ISNULL([DocumentUserState].[Read], 0) as bit)
	FROM
		[MailItem] LEFT OUTER JOIN [DocumentUserState]
			ON ([DocumentUserState].[UserID] = @UserID AND 
				[DocumentUserState].[DocumentClass] = @Class AND 
				[DocumentUserState].[DocumentID] = [MailItem].[ID])	
	WHERE
		[MailItem].[ID] = @ID
	
	
	UPDATE [MailItem]
	SET
		[State] = @State,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID
		
	IF @State = 2
	BEGIN
		EXEC adfMailItemSetRead @ID, @Read
	END

	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemChangeState] TO PUBLIC
GO
  