IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPersonIdentityCardUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfPersonIdentityCardUpdate'
		DROP  Procedure  adfPersonIdentityCardUpdate
	END

GO

PRINT 'Creating Procedure adfPersonIdentityCardUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfPersonIdentityCardUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.03.13	SAP				  OPENXML
*******************************************************************************/
CREATE Procedure adfPersonIdentityCardUpdate
	@doc Xml,	
	@EmployeeID TIdentifier
AS
	DECLARE @XPath nvarchar(256)
	SET NOCOUNT ON

	
	DELETE [IdentityCard] WHERE [EmployeeID] = @EmployeeID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	INSERT [IdentityCard]
		([EmployeeID], [IdentityCardTypeID], [Seria], [Number], [IssueDate], [Issuer], [ExpirationDate],
		[Expired])
	SELECT
		@EmployeeID,
		T.c.value('IdentityCardTypeID[1]','int'),
		T.c.value('Seria[1]','varchar(32)'),
		T.c.value('Number[1]','varchar(32)'),
		CONVERT(datetime, T.c.value('IssueDate[1]','varchar(19)'), 126),
		T.c.value('Issuer[1]','nvarchar(256)'),
		CONVERT(datetime, T.c.value('ExpirationDate[1]','varchar(19)'), 126),
		(CASE 
			WHEN T.c.value('Expired[1]','varchar(5)')='false' THEN 0 
			ELSE 1 
		END)
	FROM
		@doc.nodes('/adfEmployeeGet/IdentityCard') AS T(c)	

	RETURN 0
GO

GRANT EXEC ON adfPersonIdentityCardUpdate TO PUBLIC
GO
