IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickerBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickerBrowse'
		DROP PROCEDURE [dbo].[adfStickerBrowse]
	END
GO

PRINT 'Creating procedure adfStickerBrowse'
GO

/******************************************************************************
**		File: adfStickerBrowse.sql
**		Name: adfStickerBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 04/14/2006 15:18:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfStickerBrowse]
	@StateSelector INT
AS
	DECLARE @UserID TIdentifier
	
	SET NOCOUNT ON
	
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT
		[Sticker].[Class],
		[Sticker].[ID],
		[Sticker].[State],
		[Sticker].[Flag],
		[Sticker].[FileAs],
		[Sticker].[RecipientUserID],
		[Sticker].[Comments],
		[Sticker].[Settings],
		[Sticker].[Created],
		[Sticker].[CreatedBy],
		[Sticker].[Modified],
		[Sticker].[ModifiedBy],
		[Sticker].[Timestamp]
	FROM
		[Sticker] LEFT OUTER JOIN [DocumentUserState] as [S]
			ON ([Sticker].[Class] = [S].[DocumentClass] AND
				[Sticker].[ID] = [S].[DocumentID] AND
				[S].[UserID] = @UserID)
	WHERE
		(@StateSelector = 0 AND [Sticker].[RecipientUserID] = @UserID)
	OR
		(@StateSelector = 1 AND [Sticker].[RecipientUserID] = @UserID AND
			([S].[Read] IS NULL OR [S].[Read] = 0))
	ORDER BY
		[Sticker].[Created] DESC
	RETURN 0
GO

GRANT EXECUTE ON [adfStickerBrowse] TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickerGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickerGet'
		DROP PROCEDURE [dbo].[adfStickerGet]
	END
GO

PRINT 'Creating procedure adfStickerGet'
GO

/******************************************************************************
**		File: adfStickerGet.sql
**		Name: adfStickerGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 04/14/2006 15:18:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfStickerGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Sticker].[Class],
		[Sticker].[ID],
		[Sticker].[State],
		[Sticker].[Flag],
		[Sticker].[FileAs],
		[Sticker].[RecipientUserID],
		[Sticker].[Comments],
		[Sticker].[Settings],
		[Sticker].[Created],
		[Sticker].[CreatedBy],
		[Sticker].[Modified],
		[Sticker].[ModifiedBy],
		[Sticker].[Timestamp]
	FROM
		[Sticker]
	WHERE
		[Sticker].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfStickerGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickerCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickerCreate'
		DROP PROCEDURE [dbo].[adfStickerCreate]
	END
GO

PRINT 'Creating procedure adfStickerCreate'
GO

/******************************************************************************
**		File: adfStickerCreate.sql
**		Name: adfStickerCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 04/14/2006 15:18:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfStickerCreate]
	@FileAs TName,
	@RecipientUserID TIdentifier,
	@Comments TNotes,
	@Settings XML
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('293db5a9-a4f2-4fe8-8dcd-28b4efa474dd')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Sticker]
		([Flag], [State], [FileAs], [RecipientUserID], [Comments], [Settings])
	VALUES
		(0, @State, @FileAs, @RecipientUserID, @Comments, @Settings)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()

	DECLARE @Class TClass
	
	SET @Class = dbo.adfGetClassByName('Adf.Sticker')

	EXEC adfDocumentSetRead @Class, @ID, 1

	EXEC adfStickerGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfStickerCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickerUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickerUpdate'
		DROP PROCEDURE [dbo].[adfStickerUpdate]
	END
GO

PRINT 'Creating procedure adfStickerUpdate'
GO

/******************************************************************************
**		File: adfStickerUpdate.sql
**		Name: adfStickerUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 04/14/2006 15:18:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfStickerUpdate
	@ID TIdentifier,
	@FileAs TName,
	@RecipientUserID TIdentifier,
	@Comments TNotes,
	@Settings XML
AS
	
	SET NOCOUNT ON
	
	UPDATE [Sticker]
	SET
		[Sticker].[FileAs] = @FileAs,
		[Sticker].[RecipientUserID] = @RecipientUserID,
		[Sticker].[Comments] = @Comments,
		[Sticker].[Settings] = @Settings,
		[Sticker].[Modified] = DEFAULT,
		[Sticker].[ModifiedBy] = DEFAULT
	WHERE
		[Sticker].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	DECLARE @Class TClass
	
	SET @Class = dbo.adfGetClassByName('Adf.Sticker')

	EXEC adfDocumentSetRead @Class, @ID, 1

	EXEC adfStickerGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfStickerUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickersDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickersDelete'
		DROP PROCEDURE [dbo].[adfStickersDelete]
	END
GO

PRINT 'Creating procedure adfStickersDelete'
GO

/******************************************************************************
**		File: adfStickersDelete.sql
**		Name: adfStickersDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfStickersDelete
	@XML XML
AS
	SET NOCOUNT ON
	
	DELETE a FROM [Sticker] a INNER JOIN (SELECT id.value('@Id','int') AS Id  FROM @XML.nodes('/Sticker/StickerId') AS ROW(id)) AS b ON a.[ID]=b.Id

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfStickersDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfStickerDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfStickerDelete'
		DROP PROCEDURE [dbo].[adfStickerDelete]
	END
GO

PRINT 'Creating procedure adfStickerDelete'
GO

/******************************************************************************
**		File: adfStickerDelete.sql
**		Name: adfStickerDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 04/14/2006 15:18:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfStickerDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE [Sticker] WHERE [Sticker].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfStickerDelete TO PUBLIC
GO
