IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServicePWProjectsBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServicePWProjectsBrowse'
		DROP PROCEDURE [dbo].[adfServicePWProjectsBrowse]
	END
GO

PRINT 'Creating procedure adfServicePWProjectsBrowse'
GO

/******************************************************************************
**		File: adfServicePWProjectsBrowse.sql
**		Name: adfServicePWProjectsBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.11.12	SAP				   ,   
**									 
**		21.12.12	SAP				   
**		03.12.12	SAP				    
**		25.03.13	SAP				  OPENXML		
*******************************************************************************/
CREATE PROCEDURE [adfServicePWProjectsBrowse]
	 @ServiceID INT,
	 @CostCentersXML XML,
	 @ProjectManagerXML XML,
	 @CustomerXML XML,
	 @WithEmptyCostCenter INT,
	 @WithEmptyManager INT,
	 @WithEmptyCustomer INT
	
	
AS
	SET NOCOUNT ON
	
	SELECT
		[Project].[ID],
		[Project].[Number],
		[Project].[FileAs],
		[ServiceAssignment].[ID] AS [AssignmentID],
		[ServiceAssignment].[Price] AS [Price],
		[ServiceAssignment].[FileAs] AS [ServiceName],
		[Project].[CurrencyCode],
		[Service].[Code] AS [ServiceCode]
	FROM
		[Project]
		INNER JOIN [ServiceAssignment] 
			ON ([Project].[ID] = [ServiceAssignment].[ProjectID] AND [ServiceAssignment].[ServiceID] = @ServiceID)
		INNER JOIN [Service]
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
	WHERE	
	(([Project].[CostCenterID] IN 
		(
		SELECT 
			T.c.value('ID[1]','int') AS [ID]
		FROM
			 @CostCentersXML.nodes('/CostCenters/CostCenter') AS T(c)		
		)
		OR (@WithEmptyCostCenter = 1 
			AND (([Project].[CostCenterID] IS NULL) 
				OR [Project].[CostCenterID] IN 
					(
					SELECT 
						T.c.value('ID[1]','int') AS [ID]
					FROM
						 @CostCentersXML.nodes('/CostCenters/CostCenter') AS T(c)
					)
				)
			)
		))
	AND (([Project].[ProjectManagerEmployeeID] IN 
		(
		SELECT 
			T.c.value('ID[1]','int') AS [ID]
		FROM
			 @ProjectManagerXML.nodes('/Managers/Manager') AS T(c)
		)
		OR (@WithEmptyManager = 1 
			AND (([Project].[ProjectManagerEmployeeID]  IS NULL) 
				OR [Project].[ProjectManagerEmployeeID] IN 
					(
					SELECT 
						T.c.value('ID[1]','int') AS [ID]
					FROM
						 @ProjectManagerXML.nodes('/Managers/Manager') AS T(c)
					)
				)
			)
		))
	AND (([Project].[CustomerCompanyID] IN 
		(
		SELECT 
			T.c.value('ID[1]','int') AS [ID]
		FROM
			 @CustomerXML.nodes('/Customers/Customer') AS T(c)
		) 
		OR (@WithEmptyCustomer = 1 
			AND (([Project].[CustomerCompanyID] IS NULL) 
				OR [Project].[CustomerCompanyID] IN
					(
					SELECT 
						T.c.value('ID[1]','int') AS [ID]
					FROM
						 @CustomerXML.nodes('/Customers/Customer') AS T(c)
					)
				)
			)
		))	
	AND	([Project].[State] = 2) AND ([ServiceAssignment].[State] = 1)
	AND [ServiceAssignment].[Price] IS NOT NULL
	
	
	IF @@ERROR != 0
	BEGIN		
		RETURN 1
	END

			
	RETURN 0
GO

GRANT EXECUTE ON [adfServicePWProjectsBrowse] TO PUBLIC
GO
 
