IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfAccessRightCheckInternal')
	BEGIN
		PRINT 'Dropping Procedure adfAccessRightCheckInternal'
		DROP  Procedure  adfAccessRightCheckInternal
	END

GO

PRINT 'Creating Procedure adfAccessRightCheckInternal'
GO
/******************************************************************************
**		File: 
**		Name: adfAccessRightCheckInternal
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfAccessRightCheckInternal
	@RightID TIdentifier, @UserID TIdentifier
AS
	SET NOCOUNT ON
	
	IF is_member('db_owner') = 1 or user_name() = 'pjmexchangesync'
		RETURN 0

	IF NOT EXISTS(
	SELECT 
			*
		FROM
			[AccessRight] a
		WHERE
			(
				a.[RightID] = @RightID 
				AND 			
				[a].[Allow] = 1
				AND
				(a.[TrusteeID] IN 
					(
						SELECT 
							[UserRole].[RoleID]
						FROM
							[UserRole]
						WHERE
							[UserRole].[UserID] = @UserID
					) 
					OR
					a.[TrusteeID] = @UserID
				)
			))
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	RETURN 0
GO

GRANT EXECUTE ON adfAccessRightCheckInternal TO PUBLIC
GO

