IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClassUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfClassUpdate'
		DROP  Procedure  adfClassUpdate
	END

GO

PRINT 'Creating Procedure adfClassUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfClassUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfClassUpdate
	@Class					TClass,
	@Code					TCode,
	@Name					TName,
	@ClassGuid				TGuid,
	@Comments				TNotes,
	@CodeIsUnique			TBool,
	@CodeIsNullable			TBool,
	@TableName				TSysname,
	@SmallImage				TPicture,
	@LargeImage				TPicture,
	@SPBrowse				TSysname,
	@SPGet					TSysname,
	@SPCreate				TSysname,
	@SPUpdate				TSysname,
	@SPChangeState			TSysname,
	@SPDelete				TSysname
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION
	
	IF @Lang = 'ru'
	BEGIN
		UPDATE [Class]
		SET
			[Class].[Code] = @Code,
			[Class].[Name] = @Name,
			[Class].[Guid] = @ClassGuid,
			[Class].[Comments] = @Comments,
			[Class].[CodeIsUnique] = @CodeIsUnique,
			[Class].[CodeIsNullable] = @CodeIsNullable,
			[Class].[TableName] = @TableName,
			[Class].[SmallImage] = @SmallImage,
			[Class].[LargeImage] = @LargeImage,
			[Class].[SPBrowse] = @SPBrowse,
			[Class].[SPGet] = @SPGet,
			[Class].[SPCreate] = @SPCreate,
			[Class].[SPUpdate] = @SPUpdate,
			[Class].[SPChangeState] = @SPChangeState,
			[Class].[SPDelete] = @SPDelete
		WHERE
			[Class].[Class] = @Class
	END
	ELSE
	BEGIN
		UPDATE [Class]
		SET
			[Class].[Code] = @Code,
			[Class].[Guid] = @ClassGuid,
			[Class].[CodeIsUnique] = @CodeIsUnique,
			[Class].[CodeIsNullable] = @CodeIsNullable,
			[Class].[TableName] = @TableName,
			[Class].[SmallImage] = @SmallImage,
			[Class].[LargeImage] = @LargeImage,
			[Class].[SPBrowse] = @SPBrowse,
			[Class].[SPGet] = @SPGet,
			[Class].[SPCreate] = @SPCreate,
			[Class].[SPUpdate] = @SPUpdate,
			[Class].[SPChangeState] = @SPChangeState,
			[Class].[SPDelete] = @SPDelete
		WHERE
			[Class].[Class] = @Class
	END
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [ClassGlobal] WHERE [Class] = @Class AND [Language] = @Lang)
	BEGIN
		UPDATE [ClassGlobal]
		SET
			[Name] = @Name,
			[Comments] = @Comments
		WHERE
			[Class] = @Class AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT INTO [ClassGlobal]
			([Class], [Language], [Name], [Comments])
		VALUES
			(@Class, @Lang, @Name, @Comments)
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	EXEC adfClassGet @Class
	
	RETURN 0
GO

GRANT EXEC ON adfClassUpdate TO PUBLIC
GO
