IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfUserBrowse'
		DROP  Procedure  adfUserBrowse
	END

GO

PRINT 'Creating Procedure adfUserBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfUserBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfUserBrowse
	@OnlyActive BIT = NULL,
	@OnlyPermanent BIT = 0
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	SET @Class = dbo.adfGetClassByName('Adf.User')
	SELECT     
		[Trustee].[ID], 
		@Class as [Class],
		[Trustee].[Name], 
		[Trustee].[DisplayName],
		[Trustee].[CreatedBy], 
		[Trustee].[ModifiedBy], 
		[Trustee].[Created], 
		[Trustee].[Modified], 
		[Trustee].[Comments],
		[User].[SQLLogin],
		[User].[NTLogin],
		[User].[Locked],
		(CASE WHEN [User].[Locked]=0 THEN 1 ELSE 2 END) as [State],
		[User].[ProductKey],
		[User].[SerialNumber],
		[User].[IsPermanent],
		[User].[InitialDate],
		[User].[ValidationData]
	FROM         
		[User] INNER JOIN [Trustee] ON [User].[ID] = [Trustee].[ID]
	WHERE
		( (([User].[IsPermanent] = 1 AND @OnlyPermanent = 1) OR (@OnlyPermanent = 0)) AND (@OnlyActive IS NULL OR (@OnlyActive = 1 AND [User].[Locked] = 0) OR (@OnlyActive = 0)))

	RETURN 0
GO

GRANT EXEC ON adfUserBrowse TO PUBLIC
GO
