IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiClassBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfuiClassBrowse'
		DROP  Procedure  adfuiClassBrowse
	END

GO

PRINT 'Creating Procedure adfuiClassBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfuiClassBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiClassBrowse
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Class].[Class],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name],
		[Class].[TableName],
		[Class].[Guid],
		ISNULL([ClassGlobal].[Comments], [Class].[Comments]) as [Comments],
		[Class].[SmallImage],
		[Class].[LargeImage]
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)
		
	RETURN 0
GO

GRANT EXEC ON adfuiClassBrowse TO PUBLIC
GO
 