IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiCommandBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfuiCommandBrowse'
		DROP  Procedure  adfuiCommandBrowse
	END

GO

PRINT 'Creating Procedure adfuiCommandBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfuiCommandBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiCommandBrowse
AS
	DECLARE @Class TClass
	
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SET @Class = dbo.adfGetClassByName('Adf.Command')

	SELECT 
		[UICommand].[ID],
		@Class as [Class],
		[UICommand].[Class] as [ClassID],
		[UICommand].[ActionID],
		[UICommand].[Name],
		ISNULL([UICommandGlobal].[Text], [UICommand].[Text]) as [Text],
		ISNULL([UICommandGlobal].[AlternateText], [UICommand].[AlternateText]) as [AlternateText],
		[UICommand].[Picture],
		[UICommand].[Shortcut],
		ISNULL([UICommandGlobal].[Comments], [UICommand].[Comments]) as [Comments],
		[UICommand].[Position],
		[UICommand].[BeginGroup],
		1 as [State]
	FROM 
		[UICommand] LEFT OUTER JOIN [UICommandGlobal]
			ON ([UICommand].[ID] = [UICommandGlobal].[ID] AND [UICommandGlobal].[Language] = @Lang)

	RETURN 0
GO

GRANT EXEC ON adfuiCommandBrowse TO PUBLIC
GO
