IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiUserCreateCommandsGet')
	BEGIN
		PRINT 'Dropping Procedure adfuiUserCreateCommandsGet'
		DROP  Procedure  adfuiUserCreateCommandsGet
	END

GO

PRINT 'Creating Procedure adfuiUserCreateCommandsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfuiUserCreateCommandsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.04.11	SYV				    ,   
**									  
**		12.09.14	GNV				     
*******************************************************************************/
CREATE Procedure adfuiUserCreateCommandsGet
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT 
		[UICommand].[Name],
		[UICommand].[BeginGroup]
	FROM 
		[adfvwUICommand] as [UICommand] INNER JOIN [Class]
			ON ([UICommand].[Class] = [Class].[Class])
	WHERE 
		[UICommand].[ID] IN (
			SELECT DISTINCT
				[TransitionTemplate].[UICommandID]
			FROM 
				[TransitionTemplate] INNER JOIN dbo.adfGetCurrentUserRights() as [Right]
					ON ([TransitionTemplate].[RightID] = [Right].[ID])
			WHERE
				[TransitionTemplate].[UICommandID] IS NOT NULL
			AND
				[TransitionTemplate].[FromState] IS NULL) 
	AND
		[UICommand].[ActionID] = 6	-- Create Document	
	AND
	--TODO:  
		[Class].[Code] NOT LIKE 'Pjm6.Budget%'
	AND 
		[UICommand].[Name] NOT IN 
		(
			--  
			'Pjm7.CreateEmployeeNorm',
			'Pjm7.CreateCompanyRelationship'
		)
	ORDER BY
		ISNULL([UICommand].[Position], 1000000000),
		[UICommand].[AlternateText]
		
	RETURN 0
GO

GRANT EXEC ON adfuiUserCreateCommandsGet TO PUBLIC
GO
