IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfwfGetInitialRight]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfwfGetInitialRight'
		DROP FUNCTION [dbo].[adfwfGetInitialRight]
	END

GO

PRINT 'Creating function adfwfGetInitialRight'
GO
/******************************************************************************
**		File: 
**		Name: adfwfGetInitialRight
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 14.07.11
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfwfGetInitialRight
	(@Guid TGuid)
RETURNS TSysname
AS
BEGIN
	DECLARE @Right TSysname

	SELECT 
		@Right = [Right].[Name]
	FROM 
		[TransitionTemplate]
		INNER JOIN [Right]
			ON [Right].[ID] = [TransitionTemplate].[RightID]
	WHERE 
		[TransitionTemplate].[FromState] IS NULL 
	AND 
		[TransitionTemplate].[Class] = (SELECT [Class].[Class] FROM [Class] WHERE [Class].[Guid] = @Guid)
	AND	
		[TransitionTemplate].[ToState] = 1
		
	RETURN @Right
END
GO