IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'NumberTemplate') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	/*==============================================================*/
	/* Table: NumberTemplate			                            */
	/*==============================================================*/
	CREATE TABLE NumberTemplate (
		ID					TIdentifier		IDENTITY,
		TemplateClass		TClass			NOT NULL,
		CompanyID			TIdentifier		NOT NULL,
		ApplyLevel			tinyint			NOT NULL DEFAULT 0,
		NumberTemplate		TName			NULL,
		NameTemplate		TName			NULL,
		Seed				TCount			NULL DEFAULT 1,
		Increment			TCount			NULL DEFAULT 1,
		DuePeriodType		tinyint			NOT NULL DEFAULT 0,
		CurrentNumber		TCount			NULL DEFAULT 1,
		PrevNumber			TCount			NULL DEFAULT 1,
		InitDate			TDate			NULL,
		CONSTRAINT NumberTemplatePK primary key  (ID)
	)


	IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'NumberAssignment') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
		/*==============================================================*/
		/* Table: NumberAssignment		                                */
		/*==============================================================*/
		CREATE TABLE NumberAssignment (
			ID					TIdentifier		IDENTITY,
			TemplateClass		TClass			NOT NULL,
			DocumentClass		TClass			NOT NULL,
			DocumentID			TIdentifier		NOT NULL,
			DuePeriodType		tinyint			NOT NULL DEFAULT 1,
			CurrentNumber		TCount			NOT NULL DEFAULT 1,
			PrevNumber			TCount			NOT NULL DEFAULT 1,
			InitDate			TDate			NULL,
			CONSTRAINT NumberAssignmentPK primary key  (ID)
		)


	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DocumentNumber') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
		DECLARE @Date TDate
		SET @Date = GETDATE()

		INSERT INTO [NumberTemplate] 
		(
			[TemplateClass],
			[CompanyID],
			[ApplyLevel],
			[Seed],
			[Increment],
			[NumberTemplate],
			[NameTemplate],
			[PrevNumber],
			[CurrentNumber],
			[DuePeriodType]
		)
		SELECT
			[DocumentClass],
			[CompanyID],
			0,
			[Seed],
			[Increment],
			[NumberTemplate],
			[NameTemplate],
			[Seed],
			[CurrentNumber],
			CASE WHEN [ValidTo] IS NULL THEN 0 WHEN @Date >= [ValidFrom] AND @Date <= [ValidTo] THEN 1 END
		FROM
			[DocumentNumber]
		WHERE
			@Date >= [ValidFrom] AND @Date <= [ValidTo] OR
			[ValidTo] IS NULL AND
			[CompanyID] IN 
			(
				SELECT [ID] FROM [Company] WHERE [Own] = 1
			)
	END
END
