﻿DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @ParameterName TName = 'Fix_BudgetCategories'

IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	DECLARE		
		@BudgetClass TClass = dbo.adfGetClassByName('Pjm6.Budget'),
		@BudgetTemplateClass TClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
		

	DECLARE @TemplateCategories TABLE
	(
		[BudgetID] INT,
		[CategoryID] INT,
		[CategoryFileAs] TName
	)

	INSERT INTO @TemplateCategories
	SELECT
		[B].[ID],
		[C].[ID],	
		[C].[FileAs]
	FROM
		[DocumentCategory] AS [DC]
		INNER JOIN [Category] AS [C] 
			ON [C].[ID] = [DC].[CategoryID]
		INNER JOIN [Budget] AS [B]
			ON [B].[ID] = [DC].[DocumentID]
	WHERE
		[DC].[DocumentClass] = @BudgetClass
		AND
		[C].[DocumentClass] = @BudgetTemplateClass	

	--SELECT * FROM @TemplateCategories

	DECLARE
		@TmpCategoryFileAs TName,
		@TmpBudgetID INT,
		@TmpOldCategoryID INT,
		@TmpNewCategoryID int
	

	IF EXISTS(SELECT 1 FROM @TemplateCategories)
		BEGIN
			DECLARE categoriesCur CURSOR LOCAL FAST_FORWARD
			FOR (SELECT [BudgetID], [CategoryID], [CategoryFileAs] FROM @TemplateCategories)
	
			OPEN categoriesCur
			FETCH NEXT FROM categoriesCur INTO @TmpBudgetID, @TmpOldCategoryID, @TmpCategoryFileAs

			WHILE(@@FETCH_STATUS = 0)
			BEGIN
				SET @TmpNewCategoryID = -1

				--Ищем существующую категорию для класса документа с аналогичным именем
				SELECT
					@TmpNewCategoryID = ISNULL([ID],-1)
				FROM
					[Category]
				WHERE
					[DocumentClass] = @BudgetClass
					AND
					[FileAs] = @TmpCategoryFileAs

				--Если ее нет - создаем
				IF @TmpNewCategoryID = -1
				BEGIN
					INSERT INTO [Category] ([State],[Flag],[DocumentClass],[FileAs])
					VALUES(1,0,@BudgetClass,@TmpCategoryFileAs)

					SET @TmpNewCategoryID = SCOPE_IDENTITY()
				END

				--Разрываем связь с категорией из шаблона
				DELETE FROM [DocumentCategory] 
				WHERE 
					[DocumentClass] = @BudgetClass
					AND
					[DocumentID] = @TmpBudgetID
					AND
					[CategoryID] = @TmpOldCategoryID

			
				-- Связываем документ с категорией
				INSERT INTO [DocumentCategory] ([DocumentClass],[DocumentID],[CategoryID])
				VALUES(@BudgetClass, @TmpBudgetID, @TmpNewCategoryID)

				FETCH NEXT FROM categoriesCur INTO @TmpBudgetID, @TmpOldCategoryID, @TmpCategoryFileAs
			END
			CLOSE categoriesCur
			DEALLOCATE categoriesCur
		END	
	

	--SELECT
	--	[DC].[DocumentID],
	--	[DC].[CategoryID],
	--	[C].[FileAs]
	--FROM
	--	[DocumentCategory] AS [DC]
	--	INNER JOIN [Category] AS [C] 
	--		ON [C].[ID] = [DC].[CategoryID]
	--WHERE
	--	[DC].[DocumentID] IN (SELECT [BudgetID] FROM @TemplateCategories)

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'fix-budgetCategories.sql')
END