﻿DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @ParameterName TName = 'FixCalculationNullValues'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN

	DECLARE @Temp TABLE
	(
		[ID] INT, 
		[TotalWithoutDiscountAndAdvanced] DECIMAL(18,2),
		[TotalWithVATWithoutDiscountAndAdvanced] DECIMAL(18,2),
		[TotalWithoutDiscountAndAdvancedPC] DECIMAL(18,2),
		[TotalWithVATWithoutDiscountAndAdvancedPC] DECIMAL(18,2)
	)
	

	INSERT INTO @Temp
	SELECT
		[C].[ID],
		[C].[TotalWithoutDiscount] - SUM(ISNULL([CAdv].[Total],0)),
		[C].[TotalWithVATWithoutDiscount] - SUM(ISNULL([CAdv].[TotalWithVAT],0)),	
		[C].[TotalWithoutDiscountPC] - SUM(ISNULL([CAdv].[TotalPC],0)),
		[C].[TotalWithVATWithoutDiscountPC] - SUM(ISNULL([CAdv].[TotalWithVATPC],0))
	FROM
		[Calculation] AS [C]
		LEFT JOIN [CalculationAdvance] AS [CA] 
			ON [CA].[CalculationID] = [C].[ID]
		LEFT JOIN [Calculation] AS [CAdv]
			ON [CAdv].[ID] = [CA].[AdvanceCalculationID]
	WHERE
		[C].[TotalWithoutDiscountAndAdvanced] IS NULL
		OR
		[C].[TotalWithVATWithoutDiscountAndAdvanced] IS NULL
		OR
		[C].[TotalWithoutDiscountAndAdvancedPC] IS NULL
		OR
		[C].[TotalWithVATWithoutDiscountAndAdvancedPC] IS NULL
	GROUP BY
		[C].[ID],
		[C].[TotalWithoutDiscount],
		[C].[TotalWithVATWithoutDiscount],
		[C].[TotalWithoutDiscountPC],
		[C].[TotalWithVATWithoutDiscountPC]

	
	ALTER TABLE [Calculation]
	DISABLE TRIGGER ALL

	UPDATE [C]
	SET [C].[TotalWithoutDiscountAndAdvanced] = [T].[TotalWithoutDiscountAndAdvanced],
		[C].[TotalWithVATWithoutDiscountAndAdvanced] = [T].[TotalWithVATWithoutDiscountAndAdvanced],
		[C].[TotalWithoutDiscountAndAdvancedPC] = [T].[TotalWithoutDiscountAndAdvancedPC],
		[C].[TotalWithVATWithoutDiscountAndAdvancedPC] = [T].[TotalWithVATWithoutDiscountAndAdvancedPC]
	FROM [Calculation] AS [C]
		INNER JOIN @Temp AS [T]
			ON [T].[ID] = [C].[ID]	
	
	ALTER TABLE [Calculation]
	ENABLE TRIGGER ALL 	
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'fix-calculation-null-values.sql')
END