DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @ParameterName TName = 'Fix_ProjectCategories'

IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	DECLARE		
		@ProjectClass TClass = [dbo].[adfGetClassByName]('Pjm5.Project'),
		@ProjectTemplateClass TClass = [dbo].[adfGetClassByName]('Pjm5.ProjectTemplate')
		

	DECLARE @TemplateCategories TABLE
	(
		[ProjectID] INT,
		[CategoryID] INT,
		[CategoryFileAs] TName
	)

	INSERT INTO @TemplateCategories
	SELECT
		[P].[ID],
		[C].[ID],	
		[C].[FileAs]
	FROM
		[DocumentCategory] AS [DC]
		INNER JOIN [Category] AS [C] 
			ON [C].[ID] = [DC].[CategoryID]
		INNER JOIN [Project] AS [P]
			ON [P].[ID] = [DC].[DocumentID]
	WHERE
		[DC].[DocumentClass] = @ProjectClass
		AND
		[C].[DocumentClass] = @ProjectTemplateClass	

	--SELECT * FROM @TemplateCategories

	DECLARE
		@TmpCategoryFileAs TName,
		@TmpProjectID INT,
		@TmpOldCategoryID INT,
		@TmpNewCategoryID int
	

	IF EXISTS(SELECT 1 FROM @TemplateCategories)
		BEGIN
			DECLARE categoriesCur CURSOR LOCAL FAST_FORWARD
			FOR (SELECT [ProjectID], [CategoryID], [CategoryFileAs] FROM @TemplateCategories)
	
			OPEN categoriesCur
			FETCH NEXT FROM categoriesCur INTO @TmpProjectID, @TmpOldCategoryID, @TmpCategoryFileAs

			WHILE(@@FETCH_STATUS = 0)
			BEGIN
				SET @TmpNewCategoryID = -1

				--        
				SELECT
					@TmpNewCategoryID = ISNULL([ID],-1)
				FROM
					[Category]
				WHERE
					[DocumentClass] = @ProjectClass
					AND
					[FileAs] = @TmpCategoryFileAs

				--   - 
				IF @TmpNewCategoryID = -1
				BEGIN
					INSERT INTO [Category] ([State],[Flag],[DocumentClass],[FileAs])
					VALUES(1,0,@ProjectClass,@TmpCategoryFileAs)

					SET @TmpNewCategoryID = SCOPE_IDENTITY()
				END

				--     
				DELETE FROM [DocumentCategory] 
				WHERE 
					[DocumentClass] = @ProjectClass
					AND
					[DocumentID] = @TmpProjectID
					AND
					[CategoryID] = @TmpOldCategoryID

			
				--    
				INSERT INTO [DocumentCategory] ([DocumentClass],[DocumentID],[CategoryID])
				VALUES(@ProjectClass, @TmpProjectID, @TmpNewCategoryID)

				FETCH NEXT FROM categoriesCur INTO @TmpProjectID, @TmpOldCategoryID, @TmpCategoryFileAs
			END
			CLOSE categoriesCur
			DEALLOCATE categoriesCur
		END	
	

	--SELECT
	--	[DC].[DocumentID],
	--	[DC].[CategoryID],
	--	[C].[FileAs]
	--FROM
	--	[DocumentCategory] AS [DC]
	--	INNER JOIN [Category] AS [C] 
	--		ON [C].[ID] = [DC].[CategoryID]
	--WHERE
	--	[DC].[DocumentID] IN (SELECT [ProjectID] FROM @TemplateCategories)

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'fix-projectCategories.sql')
END