  IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'AmountBeforeFinanceDocumentInsert' AND 
	OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EntryAmount')
  BEGIN
      ALTER TABLE [EntryAmount]
      ADD [AmountBeforeFinanceDocumentInsert] TAmount not null default 0
      
      EXEC adfParameterSet 'AmountBeforeFinanceDocumentInsertAdded','ChangeScript',1     
  END
  GO
  
  
  DECLARE @created bit  
  
  SELECT @created = CONVERT(bit,[Value])
  FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] 
  WHERE [Name] = 'AmountBeforeFinanceDocumentInsertAdded' AND [Group] = 'ChangeScript'
  
  DELETE FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
  WHERE [Name] = 'AmountBeforeFinanceDocumentInsertAdded' AND [Group] = 'ChangeScript'
  
  IF @created = 1
  BEGIN
	UPDATE [EntryAmount]
      SET [AmountBeforeFinanceDocumentInsert] = [Amount]     
  END
  GO
  
DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @ParameterName TName = 'UpdateEntryAmount_FillEmptyAmountBeforeFinanceDocumentInserting'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	UPDATE [EntryAmount]
	SET [AmountBeforeFinanceDocumentInsert] = 
		CASE
			WHEN [State] != 6 THEN [Amount]
			ELSE ROUND([RoundedDuration] / 60.0, 2)
		END
	FROM [EntryAmount]
	INNER JOIN [TimeEntry]
		ON [TimeEntry].[ID] = [EntryAmount].[ID]
	WHERE [AmountBeforeFinanceDocumentInsert] = 0

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-entryAmount.sql')
END
GO

--        " "
IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Modified' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EntryAmount')
	ALTER TABLE [EntryAmount] ADD [Modified] TDate null
	
IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ModifiedBy' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EntryAmount')
	ALTER TABLE [EntryAmount] ADD [ModifiedBy] TUserID null
	
IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ModifiedInFinance' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EntryAmount')
	ALTER TABLE [EntryAmount] ADD [ModifiedInFinance] TDate null
	
IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ModifiedByInFinance' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EntryAmount')
	ALTER TABLE [EntryAmount] ADD [ModifiedByInFinance] TUserID null
GO