IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'MailItem') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	/*==============================================================*/
	/* Table: MailItem                                              */
	/*==============================================================*/
	create table MailItem (
	   Class                TClass               not null,
	   ID                   TIdentifier          identity,
	   State                TState               not null,
	   Flag                 TFlag                not null,
	   FileAs               TName                not null,
	   EventType            TName                not null,
	   FromID               TIdentifier          not null,
	   ToID                 TIdentifier          not null,
	   DocumentID           TIdentifier          not null,
	   DocumentClass        TClass               not null,
	   [Read]               TBool                not null default 0,
	   [Data]               xml                  null,
	   Comments             TNotes               null,
	   Created              TSysDateTime         not null default GETDATE(),
	   CreatedBy            TUserID              not null,
	   Modified             TSysDateTime         not null default GETDATE(),
	   ModifiedBy           TUserID              not null,
	   Timestamp            timestamp            not null,
	   constraint MailItemPK primary key  (ID)
	)
go


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'MailItemRecipient') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	/*==============================================================*/
	/* Table: MailItemRecipient                                     */
	/*==============================================================*/
	create table MailItemRecipient (
	   RecipientId          TIdentifier          not null,
	   Created              TSysDateTime         not null,
	   LogonTime            TSysDateTime         not null,
	   Enabled              TBool                not null default 1,
	   constraint MailItemRecipientPK primary key  (RecipientId)
	)
go

IF  NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[MailItemEventType]') AND type in (N'U'))
BEGIN
	/*==============================================================*/
	/* Table: MailItemEventType                                     */
	/*==============================================================*/
	create table MailItemEventType (
	   EventType            TName                not null,
	   FileAs               TName                not null,
	   constraint MailItemEventTypePK primary key  (EventType)
	)
END
GO

IF  NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[MailItemEventTypeGlobal]') AND type in (N'U'))
BEGIN
	/*==============================================================*/
	/* Table: MailItemEventTypeGlobal                               */
	/*==============================================================*/
	create table MailItemEventTypeGlobal (
	   EventType            TName                not null,
	   Language             TLanguage            not null,
	   FileAs               TName                not null,
	   constraint MailItemEventTypeGlobalPK primary key  (EventType, Language)
	)
END
GO
