﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[CleanUpSyncDataInternal]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure CleanUpSyncDataInternal'
	drop procedure [exch].[CleanUpSyncDataInternal]
end
go

print 'Creating procedure CleanUpSyncDataInternal'
go

create procedure [exch].[CleanUpSyncDataInternal]
with execute as 'pjmexchangesync'
as
begin
	
	set nocount on;

	begin transaction;

	delete from [exch].[ExchangeLink];
	if @@error != 0
	begin
		rollback transaction;
		return 1;
	end

	delete from [exch].[SyncState];
	if @@error != 0
	begin
		rollback transaction;
		return 1;
	end

	commit transaction;

	exec [dbo].[adfParameterSet] 'CleanUpSyncData', 'ExchangeSync', 0;

	return 0;
end;
go


grant execute on [exch].[CleanUpSyncDataInternal] to [projectmateservice];
go
