﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[ExchangeLinkUpdate]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure ExchangeLinkUpdate'
	drop procedure [exch].[ExchangeLinkUpdate]
end
go

print 'Creating procedure ExchangeLinkUpdate'
go

create procedure [exch].[ExchangeLinkUpdate] @userID TIdentifier, @class TName, @documentID TIdentifier, @exchangeID varchar(max), @data xml, @syncTime TDateTime
with execute as 'pjmexchangesync'
as
begin
	set nocount on;

	declare @documentClass TClass, @rowVersion bigint;

	set @documentClass = dbo.adfGetClassByName(@Class);

	select @rowVersion = @data.value('(//@RowVersion)[1]', 'bigint');

	update [exch].[ExchangeLink]
	set
		[ExchangeID] = @exchangeID,
		[Data] = @data,
		[SyncTime] = @syncTime,
		[RowVersion] = @rowVersion
	where
		[UserID] = @userID and [DocumentClass] = @documentClass and [DocumentID] = @documentID
	return 0;
end

GO


grant execute on [exch].[ExchangeLinkUpdate] to [projectmateservice];
go
