﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[UpdateAddress]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure UpdateAddress'
	drop procedure [exch].[UpdateAddress]
end
go

print 'Creating procedure UpdateAddress'
go

create procedure [exch].[UpdateAddress] @XContact xml, @Class TClass, @ID TIdentifier
as
begin
	set nocount on;

	update [dbo].[Address]
	set
		[Street] = [S].[Street],
		[City] = [S].[City],
		[Region] = [S].[Region],
		[PostalCode] = [S].[PostalCode],
		[Country] = [S].[Country],
		[Mail] = [S].[Mail]
	from
		[dbo].[Address] as [P] inner join (
		select
			@Class as [Class],
			@ID as [ID],
			T.C.value('(@TypeID)[1]', 'int') as [TypeID],
			T.C.value('(@Street)[1]', 'nvarchar(256)') as [Street],
			substring(T.C.value('(@City)[1]', 'nvarchar(256)'), 1, 50) as [City],
			T.C.value('(@Region)[1]', 'nvarchar(256)') as [Region],
			substring(T.C.value('(@PostalCode)[1]', 'nvarchar(256)'),1, 10) as [PostalCode], 
			T.C.value('(@Country)[1]', 'nvarchar(256)') as [Country],
			T.C.value('(@Mail)[1]', 'bit') as [Mail]
		from
			@XContact.nodes('Contact/Address') as T(C)) as [S]
		on ([P].[BusinessCardClass] = [S].[Class] and [P].[BusinessCardID]=[S].[ID] and [P].[AddressTypeID] = [S].[TypeID])


	insert into [dbo].[Address]	
		([BusinessCardClass], [BusinessCardID], [AddressTypeID], [Street], [City], [Region], [PostalCode], [Country], [Mail])
	select
		@Class,
		@ID,
		T.C.value('(@TypeID)[1]', 'int'),
		T.C.value('(@Street)[1]', 'nvarchar(256)') as [Street],
		substring(T.C.value('(@City)[1]', 'nvarchar(256)'), 1, 50) as [City],
		T.C.value('(@Region)[1]', 'nvarchar(256)') as [Region],
		substring(T.C.value('(@PostalCode)[1]', 'nvarchar(256)'),1, 10) as [PostalCode], 
		T.C.value('(@Country)[1]', 'nvarchar(256)') as [Country],
		T.C.value('(@Mail)[1]', 'bit') as [Mail]
	from
		@XContact.nodes('Contact/Address') as T(C)
	where
		T.C.value('(@TypeID)[1]', 'int') not in (select [AddressTypeID] from [Address] 
												 where [BusinessCardClass] = @Class 
												 and [BusinessCardID] = @ID);
	return 0;
end
GO


