IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetSortedBudgetGroup') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetSortedBudgetGroup'
		DROP FUNCTION [dbo].fnPjm6GetSortedBudgetGroup
	END

GO

PRINT 'Creating function fnPjm6GetSortedBudgetGroup'
GO
/******************************************************************************
**		File:	fnPjm6GetSortedBudgetGroup.sql
**		Name: 	fnPjm6GetSortedBudgetGroup
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetSortedBudgetGroup(
	@GroupName		TName,
	@Order			TCount,
	@MaxGroupWidth	TCount)
RETURNS nvarchar(max)
BEGIN
	DECLARE
		@StringOrder	nvarchar(max),
		@ZeroCount		TCount,
		@FullGroupName	nvarchar(max)
	
	SET @StringOrder = CAST(@Order AS nvarchar(max))
	
	SET @FullGroupName = ''
	SET @ZeroCount = @MaxGroupWidth + 1 - LEN(@StringOrder)
	WHILE (@ZeroCount > 0)
	BEGIN
		SET @FullGroupName = @FullGroupName + '0'
		SET @ZeroCount = @ZeroCount - 1
	END
	SET @FullGroupName = @FullGroupName + @StringOrder + '. ' + @GroupName
	
	RETURN @FullGroupName
END
GO

GRANT EXEC ON fnPjm6GetSortedBudgetGroup TO PUBLIC
GO