IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetAvailableProjectsForProjectMember]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetAvailableProjectsForProjectMember'
		DROP FUNCTION [dbo].[fnPjm6GetAvailableProjectsForProjectMember]
	END

GO

PRINT 'Creating function fnPjm6GetAvailableProjectsForProjectMember'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForProjectMember.sql
**		Name: 	fnPjm6GetAvailableProjectsForProjectMember
**		Desc:	      
**				   
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	26.03.09	ENB			 
**		13.07.11	SYV			   UseSubProjects
**		03.04.13	SOV			    . - 
**								     " "
*******************************************************************************/
CREATE FUNCTION fnPjm6GetAvailableProjectsForProjectMember ()

RETURNS @Projects TABLE ([ID] INT PRIMARY KEY, [ViewFinance] INT NOT NULL DEFAULT 0, [ParentProjectID] INT)

AS 

BEGIN

	DECLARE 
		@CurrentEmployeeID	TIdentifier
		--@UseSubProjects		TBool,
		--@value				TVariant

--   	
	--EXEC adfParameterGet @Name='UseSubProjects', @Group='Pjm6', @Value = @value OUTPUT
	--SET @UseSubProjects = ISNULL(CAST(@value as bit), 0)	

--   
	SELECT 
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

--   ,    
--  !!! 
--    AssignmentEntry  ,   
	INSERT INTO @Projects ([ID], [ViewFinance], [ParentProjectID])
	SELECT
		[Assignment].[ProjectID], 
		dbo.fnPjm5HasFinansDataAccess([Assignment].[ProjectID], @CurrentEmployeeID, NULL, NULL),
		[SubProjects].[ProjectID]
	FROM
        [Assignment] 
		LEFT OUTER JOIN dbo.fnpjm6GetSubprojectsForBrowse() AS [SubProjects]
			ON [SubProjects].[SubprojectID] = [Assignment].[ProjectID]
	WHERE 	
        [Assignment].[ID] IN (
			SELECT [AssignmentEntry].AssignmentID
			FROM   [AssignmentEntry]
			WHERE  
				[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID 
 		) AND
	   ([Assignment].[State] = 1)
	
	--IF @UseSubProjects = 1
	UPDATE @Projects
	SET [ParentProjectID] = NULL
	WHERE
		[ParentProjectID] IS NOT NULL AND
		[ParentProjectID] NOT IN (SELECT [ID] FROM @Projects)

--        ,   
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProject')) = 1 BEGIN
		UPDATE @Projects SET [ViewFinance] = 1
		WHERE ID IN (
			SELECT	ID 
			FROM	[Project] 
			WHERE	[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
		)
	END

	RETURN

END
	
GO
