﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7ExchangeSyncIsProjectManager]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7ExchangeSyncIsProjectManager'
		DROP FUNCTION [dbo].[fnPjm7ExchangeSyncIsProjectManager]
	END

GO

PRINT 'Creating function fnPjm7ExchangeSyncIsProjectManager'
GO
/******************************************************************************
**		File: fnPjm7ExchangeSyncIsProjectManager.sql
**		Name: fnPjm7ExchangeSyncIsProjectManager
**		Desc: Функция проверяет является ли сотрудник руководителем проекта
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov	
**		Date: 20.04.12 15:45
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7ExchangeSyncIsProjectManager
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN
	DECLARE 
		@result BIT,
		@UserID		TIdentifier,
		@ProjectManagerEmployeeID TIdentifier
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT @ProjectManagerEmployeeID = [ProjectManagerEmployeeID] FROM [Project] WHERE [ID] = @ProjectID
		
	SELECT @UserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID AND [State] = 1

	IF @UserID IS NULL
		RETURN 0

	IF @EmployeeID = @ProjectManagerEmployeeID AND 
		dbo.adfHasAccessRightByNameForUser('ManageProject', @UserID) = 1
		SET @result = 1
	ELSE
		SET @result = 0
	
	RETURN @result
END
GO

GRANT EXEC ON fnPjm7ExchangeSyncIsProjectManager TO PUBLIC
GO

