IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6FormatMoney]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6FormatMoney'
		DROP FUNCTION [dbo].[fnPjm6FormatMoney]
	END

GO

PRINT 'Creating function fnPjm6FormatMoney'
GO
/******************************************************************************
**		File: fnPjm6FormatMoney.sql
**		Name: fnPjm6FormatMoney
**		Desc: this function is nessesary for format decimal like (1 234 567,89)
**		for using argument should be in next format: 9...99.99
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		09.07.2010	SPV				first version
*******************************************************************************/
CREATE FUNCTION fnPjm6FormatMoney
	(@String varchar(32))
RETURNS varchar(32)
AS
BEGIN

	DECLARE @Len int, @Result varchar(15), @Index int
	
	SET @Len = LEN(@String)
	
	IF (CHARINDEX('.', @String) > 0)
		RETURN
			dbo.fnPjm6FormatMoney(SUBSTRING(@String, 0, @len - 2)) + ',' + SUBSTRING(@String, @len - 1, 2)
	
	IF @Len > 3
		RETURN
			dbo.fnPjm6FormatMoney(SUBSTRING(@String, 0, @len - 2)) + ' ' + SUBSTRING(@String, @len - 2, 3)
	
	RETURN @String
END
GO
