IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetCalculationTotal]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetCalculationTotal'
		DROP FUNCTION [dbo].[fnPjm6GetCalculationTotal]
	END

GO

PRINT 'Creating function fnPjm6GetCalculationTotal'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetCalculationTotal
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 25.03.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		18.12.12	SOV				    -  
**		27.03.13	SOV				    2   
*******************************************************************************/
CREATE FUNCTION fnPjm6GetCalculationTotal(@DiscountType TIdentifier, @DiscountView TBool, @DiscountPercent TPercent, @Discount TAmount,  @Cost TMoney)
RETURNS TMoney
AS
BEGIN
	
	IF @DiscountView = 0
		SET @Discount = ROUND(@Cost * @DiscountPercent, 2)

	IF (@DiscountType = 1)
	BEGIN
		--
		IF(@Cost > @Discount)
		BEGIN
			RETURN @Cost - @Discount
		END
		RETURN 0
	END
	
	IF (@DiscountType = 2)
	BEGIN
		--
		RETURN @Cost + @Discount
	END
		
	IF (@DiscountType = 3)
	BEGIN
		--
		IF(@Cost > @Discount)
		BEGIN
			RETURN @Discount
		END
		RETURN @Cost
	END
	
	IF (@DiscountType = 4)
	BEGIN
		-- 
		RETURN @Discount
	END

	RETURN @Cost
END
GO

GRANT EXEC ON fnPjm6GetCalculationTotal TO PUBLIC
GO
