IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetProjectBankAccountCurrency]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetProjectBankAccountCurrency'
		DROP FUNCTION [dbo].[fnPjm6GetProjectBankAccountCurrency]
	END

GO

PRINT 'Creating function fnPjm6GetProjectBankAccountCurrency'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetProjectBankAccountCurrency
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetProjectBankAccountCurrency
	(@ProjectID TIdentifier)
RETURNS TCode3
AS
BEGIN
	DECLARE
		@BankAccountID TIdentifier,
		@CurrencyCode TCode3
		
	SELECT
		@BankAccountID = [Project].[BankAccountID]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ProjectID
		
	IF(@BankAccountID IS NULL)
	BEGIN
		SELECT
			@BankAccountID = [Company].[BankAccountID]
		FROM
			[Project]
			INNER JOIN [Company]
				ON [Project].[SupplierCompanyID] = [Company].[ID]
		WHERE
			[Project].[ID] = @ProjectID
	END
	
	SELECT
		@CurrencyCode = [BankAccount].[CurrencyCode]
	FROM
		[BankAccount]
	WHERE
		[BankAccount].[ID] = @BankAccountID
	
	RETURN @CurrencyCode
END
GO

GRANT EXECUTE ON dbo.fnPjm6GetProjectBankAccountCurrency TO PUBLIC
GO


  