 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsProjectEnhancementMember]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsProjectEnhancementMember'
		DROP FUNCTION [dbo].[fnPjm5IsProjectEnhancementMember]
	END

GO

PRINT 'Creating function fnPjm5IsProjectEnhancementMember'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsProjectEnhancementMember
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.04.13	SOV				   . -
*******************************************************************************/
CREATE FUNCTION fnPjm5IsProjectEnhancementMember
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN

	DECLARE @result BIT
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm7IsManagerAssistant(@ProjectID, @EmployeeID) = 1 OR 
		EXISTS(
		SELECT * FROM vwAssignment 
		WHERE 
			[EmployeeID] = @EmployeeID AND 
			[ProjectID] = @ProjectID AND 
			([Administrator] = 1 OR [Approver] = 1) AND
			[State] = 1)
		SET @result = 1
	ELSE
		SET @result = 0
	
	RETURN @result
END
GO

GRANT EXEC ON fnPjm5IsProjectEnhancementMember TO PUBLIC
GO
