IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetEntryDescription]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetEntryDescription'
		DROP FUNCTION [dbo].[fnPjm5GetEntryDescription]
	END

GO

PRINT 'Creating function fnPjm5GetEntryDescription'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetEntryDescription
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.11.12	SOV				     
*******************************************************************************/
CREATE FUNCTION fnPjm5GetEntryDescription(
	@Str1		TName,
	@Str2		TName,
	@Str6		TName,
	@Str7		TNotes,
	@Str3		TName,
	@Str4		TName,
	@Str5		TName,
	@Separator1	TName,
	@Separator2	TName,
	@Separator3	TName,
	@Separator4	TName,
	@Separator5	TName,
	@Separator6	TName,
	@Default	TNotes
	)
RETURNS TNotes
AS
BEGIN
	SET @Str1 = ISNULL(LTRIM(RTRIM(@Str1)), '')
	SET @Str2 = ISNULL(LTRIM(RTRIM(@Str2)), '')
	SET @Str3 = ISNULL(LTRIM(RTRIM(@Str3)), '')
	SET @Str4 = ISNULL(LTRIM(RTRIM(@Str4)), '')
	SET @Str5 = ISNULL(LTRIM(RTRIM(@Str5)), '')
	SET @Str6 = ISNULL(LTRIM(RTRIM(@Str6)), '')
	SET @Str7 = ISNULL(LTRIM(RTRIM(@Str7)), '')

	DECLARE 
		@Value TNotes, 
		@val TNotes,
		@l1 int, @l2 int, @l3 int, @l4 int, @l5 int, @l6 int, @l7 int

	SET @l1 = LEN(@Str1)
	SET @l2 = LEN(@Str2)
	SET @l3 = LEN(@Str3)
	SET @l4 = LEN(@Str4)
	SET @l5 = LEN(@Str5)
	SET @l6 = LEN(@Str6)
	SET @l7 = LEN(@Str7)
	
	IF @l1 > 0 
	BEGIN
		SET @Value = @Str1
		IF (@l2 + @l3 + @l4 + @l5 + @l6 + @l7) > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator1 SET @Value = @Value + @Separator1
		END
	END
	IF @l2 > 0
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str2
		IF (@l3 + @l4 + @l5 + @l6 + @l7) > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator2 SET @Value = @Value + @Separator2
		END
	END
	IF @l3 > 0
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str3
		IF (@l4 + @l5 + @l6 + @l7) > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator4 SET @Value = @Value + @Separator4
		END
	END
	IF @l4 > 0
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str4
		IF (@l5 + @l6 + @l7) > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator5 SET @Value = @Value + @Separator5
		END
	END
	IF @l5 > 0
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str5
		IF (@l6 + @l7) > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator6 SET @Value = @Value + @Separator6
		END
	END
	IF @l6 > 0
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str6
		IF @l7 > 0
		BEGIN
			SET @val = RIGHT(@Value, 1)
			IF @val != @Separator3 SET @Value = @Value + @Separator3
		END
	END
	IF @l7 > 0 
	BEGIN
		SET @Value = ISNULL(@Value, '') + @Str7
	END

	RETURN ISNULL(@Value, @Default)
END
 