IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsDocumentAssignedTo]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsDocumentAssignedTo'
		DROP FUNCTION [dbo].[fnPjm5IsDocumentAssignedTo]
	END

GO

PRINT 'Creating function fnPjm5IsDocumentAssignedTo'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsDocumentAssignedTo
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5IsDocumentAssignedTo
	(@DocumentClass TClass, @DocumentID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN
	DECLARE @IsAssigned BIT, @AssignmentID TIdentifier, @UserID TIdentifier

	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SET @UserID = dbo.adfGetCurrentUserID()

	DECLARE @ProjectID TIdentifier, @ClassName TCode

	SELECT @ClassName = [Code] FROM [Class] WHERE [Class] = @DocumentClass

	SET @ProjectID = dbo.fnPjm5GetDocumentProject(@DocumentClass, @DocumentID)	
	
	SET @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @EmployeeID)
	
	IF @AssignmentID IS NULL
	BEGIN
		SET @IsAssigned = 0
	END
	ELSE			
	BEGIN
		SET @IsAssigned = 1
		IF @ClassName = 'Pjm5.Issue' 
		BEGIN
			IF NOT EXISTS(SELECT * FROM [Issue] WHERE [EmployeeID] = @EmployeeID AND [ID] = @DocumentID)
				SET @IsAssigned = 0
			IF @IsAssigned = 0 AND EXISTS(SELECT * FROM [Issue] WHERE [CreatedBy]=@UserID AND [ID]=@DocumentID)
				SET @IsAssigned = 1
		END
		ELSE IF @ClassName = 'Pjm5.ServiceRequest'
		BEGIN
			IF NOT EXISTS(SELECT * FROM [ServiceRequest] WHERE [EmployeeID] = @EmployeeID AND [ID] = @DocumentID)
				SET @IsAssigned = 0
		END
		ELSE IF @ClassName = 'Pjm5.Task'
		BEGIN
			IF NOT EXISTS(SELECT * FROM [TaskAssignment] WHERE [AssignmentID]=@AssignmentID AND [TaskID] = @DocumentID)
				SET @IsAssigned = 0
		END
	END	
	RETURN @IsAssigned
END
GO

GRANT EXECUTE ON fnPjm5IsDocumentAssignedTo TO PUBLIC
GO


  