IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6CheckForExchangeBanned]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6CheckForExchangeBanned'
		DROP FUNCTION [dbo].[fnPjm6CheckForExchangeBanned]
	END

GO

PRINT 'Creating function fnPjm6CheckForExchangeBanned'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6CheckForExchangeBanned
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION [dbo].[fnPjm6CheckForExchangeBanned](@ID TIdentifier, @Class TName)
RETURNS BIT
AS
BEGIN
	
	DECLARE @Result TBool 
	
	IF(@Class = 'Pjm5.Invoice')
	BEGIN
		SELECT
			@Result = CASE WHEN ([Invoice].[ExchangeBanned] = 1 OR [Company].[ExchangeBanned] = 1) THEN 1 ELSE 0 END
		FROM
			[Invoice]
			INNER JOIN [Company]
				ON [Invoice].[SupplierCompanyID] = [Company].[ID]
		WHERE
			[Invoice].[ID] = @ID
	END
	ELSE IF(@Class = 'Pjm5.Facture')
	BEGIN
		SELECT
			@Result = CASE WHEN ([Facture].[ExchangeBanned] = 1 OR [Company].[ExchangeBanned] = 1) THEN 1 ELSE 0 END
		FROM
			[Facture]
			INNER JOIN [Company]
				ON [Facture].[SupplierCompanyID] = [Company].[ID]
		WHERE
			[Facture].[ID] = @ID
	END
	ELSE IF(@Class = 'Pjm5.Statement')
	BEGIN
		SELECT
			@Result = CASE WHEN ([Statement].[ExchangeBanned] = 1 OR [Company].[ExchangeBanned] = 1) THEN 1 ELSE 0 END
		FROM
			[Statement]
			INNER JOIN [Company]
				ON [Statement].[SupplierCompanyID] = [Company].[ID]
		WHERE
			[Statement].[ID] = @ID
	END
	ELSE
		RETURN 1
	RETURN @Result
	
END
GO

GRANT EXEC ON fnPjm6CheckForExchangeBanned TO PUBLIC
GO