﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnpjm7CompanyFindSingleParent]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnpjm7CompanyFindSingleParent'
		DROP FUNCTION [dbo].[fnpjm7CompanyFindSingleParent]
	END
GO

PRINT 'Creating function fnpjm7CompanyFindSingleParent'
GO

/******************************************************************************
**		File: fnpjm7CompanyFindSingleParent.sql
**		Name: fnpjm7CompanyFindSingleParent
**
**              
**		Return values:
**		Функция возвращает самого "верхнего" родителя в иерархии для указанной дочерней компании
**
**		Called by:   
**              ReportPaymentsByClients
**		Parameters:
**		Input							Output
**      ----------						-----------
**		
**		
**		Auth: Sergey Pelevin
**		Date: 08.09.14 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		18.09.14	GNV			Исправление сравнения с NULL 
*******************************************************************************/
CREATE FUNCTION dbo.fnpjm7CompanyFindSingleParent
(
	@ChildCompanyID int	
)
RETURNS int 
AS
BEGIN

	DECLARE
		@RelationType nvarchar(20) = 'Головная компания',
		@TmpChildCompanyID int = @ChildCompanyID,
		@ParentCompanyID int

	WHILE 1 = 1
	BEGIN
	
		SELECT 
			@ParentCompanyID = [CRE].[SecondCompanyID]
		FROM 
			[CompanyRelationshipEntry] AS [CRE] 
		WHERE 
			[CRE].[FirstCompanyID] = @TmpChildCompanyID 
			AND
			[CRE].[FileAs] = @RelationType

		IF (@ParentCompanyID IS NULL)
		BEGIN
			-- Значит глубже мы уже не опустимся, и дальнейшие проверки на "неравенство" бессмысленны 
			RETURN @TmpChildCompanyID
		END

		IF EXISTS (SELECT 1 FROM [CompanyRelationshipEntry] AS [CRE1] WHERE [CRE1].[FirstCompanyID] = @ParentCompanyID)
			AND @TmpChildCompanyID <> @ParentCompanyID
		BEGIN		
			SET @TmpChildCompanyID = @ParentCompanyID
		END
		ELSE
		BEGIN		
			RETURN @ParentCompanyID
			BREAK
		END
	END
	
	RETURN NULL	
END

GO