IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5BudgetGet'
		DROP PROCEDURE [dbo].[pjm6BudgetGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetGet'
GO

/******************************************************************************
**		File: pjm6BudgetGet.sql
**		Name: pjm6BudgetGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 24/09/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.11.12	MAB				   
**		21.02.13	MAB				  " "  " "
**		12.03.13	MAB				      
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE
		@BudgetClass				TClass,
		@RecurrencePatternID		TIdentifier,
		@UserID						TIdentifier,
		@Lang						TLanguage
	
	IF dbo.fnPjm6CanEditBudget(@ID) != 1 AND dbo.fnPjm6CanViewBudget(@ID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @Lang = dbo.adfGetLanguage()
	SET @UserID = dbo.adfGetCurrentUserID()

	SET @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget')
	SELECT @RecurrencePatternID = [RecurrencePatternID] FROM [Document] WHERE [Document].[Class] = @BudgetClass AND [Document].[ID] = @ID

	SELECT
		[Budget].[ID],
		[Budget].[Class],
		[Budget].[State],
		[Budget].[Flag],
		CASE @Lang
			WHEN 'en' THEN 'Budget for project ''' + [Project].[Number] + '''' ELSE
			'   ''' + [Project].[Number] + '''' END as [FileAs],
		[Budget].[DocumentClass],
		[Budget].[DocumentID],
		[Project].[State] AS [ProjectState],
		[Budget].[BudgetTypeID],
		dbo.fnPjm6GetBudgetPeriodName([Budget].[StartDate], [Budget].[EndDate], [BudgetTypeID], @Lang, 1) AS [Period],
		(CASE [Budget].[BudgetTypeID] WHEN 1 THEN [Project].[Date] ELSE [Budget].[StartDate] END) AS [StartDate],
		(CASE [Budget].[BudgetTypeID] WHEN 1 THEN [Project].[EndDate] ELSE [Budget].[EndDate] END) AS [EndDate],
		[ProjectDetail].[DueDate],
		[Budget].[WarningFlagID],
		ISNULL([BudgetWarningFlagGlobal].[FileAs], [BudgetWarningFlag].[FileAs]) AS [WarningMessage],
		[BudgetWarningFlag].[WarningType],
		[Budget].[UseWorkPlanning],
		[Budget].[UseExpensePlanning],
		[Budget].[WorkBudgetBottom],
		[Budget].[WorkBudgetHigh],
		[Budget].[WorkBudgetBottomEqualsPlan],
		[Budget].[WorkBudgetHighEqualsPlan],
		[Budget].[ExpenseBudgetBottom],
		[Budget].[ExpenseBudgetHigh],
		[Budget].[ExpenseBudgetBottomEqualsPlan],
		[Budget].[ExpenseBudgetHighEqualsPlan],
		[Budget].[LastCalculationDate],
		dbo.fnPjm6GetDurationFormatted([Budget].[CalculationDuration]) AS [CalculationDuration],
		[Budget].[NextCalculationDate],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		[Budget].[SupervisorEmployeeID],
		[Budget].[CalculatedEmployeeID],
		[Budget].[CalculateBudgetPatternID],
		[Budget].[CurrencyCode],
		[Budget].[VATRate],
		[Budget].[VATIsIncluded],
		[Budget].[DiscountViewWork],
		ABS([Budget].[DiscountPercentWork]) AS [DiscountPercentWork],
		ABS([Budget].[DiscountTotalWork]) AS [DiscountTotalWork],
		CASE WHEN [DiscountPercentWork] > 0 OR [DiscountTotalWork] > 0 THEN 2
			WHEN [DiscountPercentWork] < 0 OR [DiscountTotalWork] < 0 THEN 1
			WHEN [DiscountPercentWork] IS NULL AND [DiscountTotalWork] IS NULL THEN 0 END  AS [DiscountTypeWork],
		[Budget].[DiscountViewExpense],
		ABS([Budget].[DiscountPercentExpense]) AS [DiscountPercentExpense],
		ABS([Budget].[DiscountTotalExpense]) AS [DiscountTotalExpense],
		CASE WHEN [DiscountPercentExpense] > 0 OR [DiscountTotalExpense] > 0 THEN 2
			WHEN [DiscountPercentExpense] < 0 OR [DiscountTotalExpense] < 0 THEN 1
			WHEN [DiscountPercentExpense] IS NULL AND [DiscountTotalExpense] IS NULL THEN 0 END AS [DiscountTypeExpense],
		[Budget].[PlanningActivityForWork],
		[Budget].[PlanningEmployeeForWork],
		[Budget].[PlanningQualificationForWork],
		[Budget].[PlanningRateForWork],
		[Budget].[PlanningDateForWork],
		[Budget].[PlanningExpenseTypeForExpense],
		[Budget].[PlanningEmployeeForExpense],
		[Budget].[PlanningPriceForExpense],
		[Budget].[PlanningDateForExpense],
		[Budget].[TimeEntryAccount],
		[Budget].[TimeEntrySendingForApprovalAccount],
		--   (0 - , 1 -  )
		[Budget].[TimeEntryActualTotalsAccount],
		([Budget].[PlanProfitability] * 100) as [PlanProfitability],
		[Budget].[ExpenseAccount],
		[Budget].[ExpenseSendingForApprovalAccount],
		[Budget].[PlanPurchases],
		[Budget].[PlannedManHour],
		[Budget].[PlannedManHourWithSub],
		[Budget].[ActualManHour],
		[Budget].[ActualManHourWithSub],
		-- --------------------------------------------------------------------------------------------------------------------------------------------------
		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour], 'ManHour') 
			AS [TotalPlannedManHour],
		--  ()
		dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour], 'ManHour'))
			AS [DiscountTotalPlannedManHour],
		--   ()
		dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [TotalWDPlannedManHour],
		--     ()
		dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [VATWDPlannedManHour],
		--     ()
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [TotalWithVATPCWDPlannedManHour],
		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualManHour], [TotalWithVATPCActualManHour], 'ManHour')
			AS [TotalActualManHour],
		--  ()
		dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualManHour], [TotalWithVATPCActualManHour], 'ManHour')) 
			AS [DiscountTotalActualManHour],
		--   ()
		dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [TotalWDActualManHour],
		--     ()
		dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [VATWDActualManHour],
		--     ()
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [TotalWithVATPCWDActualManHour],
		-------------------------------------------------------------------------------------------------------------------------------------------------------------------
		--  ()
		(CASE
			WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
				[TotalWithVATPCPlannedExpense]
			ELSE
				[TotalPCPlannedExpense]
		END) AS [TotalPlannedExpense],
		--  ()
		dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense], 'Expense'))
			AS [DiscountTotalPlannedExpense],
		--   ()
		dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))
			AS [TotalWDPlannedExpense],
		--     ()
		(CASE
			WHEN [DiscountTotalExpense] IS NULL AND [DiscountPercentExpense] IS NULL THEN
				([TotalWithVATPCPlannedExpense] - [TotalPCPlannedExpense])
			ELSE
				dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))
		END) AS [VATWDPlannedExpense],
		--     ()
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))
			AS [TotalWithVATPCWDPlannedExpense],

		[Budget].[VATPCPlanPurchase],	--    
		[Budget].[TotalPCPlanPurchase],	--   

		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualExpense], [TotalWithVATPCActualExpense], 'Expense') 
			AS [TotalActualExpense],
		--  ()
		dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualExpense], [TotalWithVATPCActualExpense], 'Expense'))
			AS [DiscountTotalActualExpense],
		--   ()
		dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))
			AS [TotalWDActualExpense],
		--     ()
		dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))
			AS [VATWDActualExpense],
		--     ()
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))
		AS [TotalWithVATPCWDActualExpense],
		-- ---------------------------------------------------------------------------------------------------------------------------------------------------
		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedManHourWithSub], [TotalWithVATPCPlannedManHourWithSub], 'ManHour') 
			AS [TotalPlannedManHourWithSub],
		--  ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDPlannedManHourWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedManHourWithSub], [TotalWithVATPCPlannedManHourWithSub], 'ManHour')
			ELSE
			[Budget].[TotalPCWDPlannedManHourWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedManHourWithSub], [TotalWithVATPCPlannedManHourWithSub], 'ManHour')
		END) AS [DiscountTotalPlannedManHourWithSub],
		--   ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDPlannedManHourWithSub]
			ELSE
			[Budget].[TotalPCWDPlannedManHourWithSub]
		END) AS [TotalWDPlannedManHourWithSub],
		--     ()
		[Budget].[VATPCWDPlannedManHourWithSub] AS [VATWDPlannedManHourWithSub],
		--     ()
		[Budget].[TotalWithVATPCWDPlannedManHourWithSub] AS [TotalWithVATPCWDPlannedManHourWithSub],
		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualManHourWithSub], [TotalWithVATPCActualManHourWithSub], 'ManHour')
			AS [TotalActualManHourWithSub],
		--  ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDActualManHourWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualManHourWithSub], [TotalWithVATPCActualManHourWithSub], 'ManHour')
			ELSE
			[Budget].[TotalPCWDActualManHourWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualManHourWithSub], [TotalWithVATPCActualManHourWithSub], 'ManHour')
		END) AS [DiscountTotalActualManHourWithSub],
		--   ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDActualManHourWithSub]
			ELSE
			[Budget].[TotalPCWDActualManHourWithSub]
		END) AS [TotalWDActualManHourWithSub],
		--     ()
		[Budget].[VATPCWDActualManHourWithSub] AS [VATWDActualManHourWithSub],
		--     ()
		[Budget].[TotalWithVATPCWDActualManHourWithSub] AS [TotalWithVATPCWDActualManHourWithSub],
		-------------------------------------------------------------------------------------------------------------------------------------------------------------------
		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedExpenseWithSub], [TotalWithVATPCPlannedExpenseWithSub], 'Expense') 
			AS [TotalPlannedExpenseWithSub],
		--  ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedExpenseWithSub], [TotalWithVATPCPlannedExpenseWithSub], 'Expense')
			ELSE
			[Budget].[TotalPCWDPlannedExpenseWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedExpenseWithSub], [TotalWithVATPCPlannedExpenseWithSub], 'Expense')
		END) AS [DiscountTotalPlannedExpenseWithSub],
		--   ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDPlannedExpenseWithSub]
			ELSE
			[Budget].[TotalPCWDPlannedExpenseWithSub]
		END) AS [TotalWDPlannedExpenseWithSub],
		--     ()
		[Budget].[VATPCWDPlannedExpenseWithSub] AS [VATWDPlannedExpenseWithSub],
		--     ()
		[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] AS [TotalWithVATPCWDPlannedExpenseWithSub],

		[Budget].[VATPCPlanPurchaseWithSub],	--     /
		[Budget].[TotalPCPlanPurchaseWithSub],	--    /

		--  ()
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualExpenseWithSub], [TotalWithVATPCActualExpenseWithSub], 'Expense') 
			AS [TotalActualExpenseWithSub],
		--  ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDActualExpenseWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualExpenseWithSub], [TotalWithVATPCActualExpenseWithSub], 'Expense')
			ELSE
			[Budget].[TotalPCWDActualExpenseWithSub] - dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCActualExpenseWithSub], [TotalWithVATPCActualExpenseWithSub], 'Expense')
		END) AS [DiscountTotalActualExpenseWithSub],
		--   ()
		(CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN
			[Budget].[TotalWithVATPCWDActualExpenseWithSub]
			ELSE
			[Budget].[TotalPCWDActualExpenseWithSub]
		END) AS [TotalWDActualExpenseWithSub],
		--     ()
		[Budget].[VATPCWDActualExpenseWithSub] AS [VATWDActualExpenseWithSub],
		--     ()
		[Budget].[TotalWithVATPCWDActualExpenseWithSub] AS [TotalWithVATPCWDActualExpenseWithSub],
		[Budget].[Comments],
		@RecurrencePatternID AS [RecurrencePatternID],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp],
		[Company].[Own] as [CompanyOwn],
		[Company].[PlanPurchases] as [CompanyPlanPurchases]
	FROM
		[Budget]
		LEFT OUTER JOIN [BudgetWarningFlag]
			ON [BudgetWarningFlag].[ID] = [Budget].[WarningFlagID]
		LEFT OUTER JOIN [BudgetWarningFlagGlobal] 
			ON ([BudgetWarningFlag].[ID] = [BudgetWarningFlagGlobal].[ID]
				AND [BudgetWarningFlagGlobal].[Language] = @Lang)
		INNER JOIN [Project]
			ON [Project].[ID] = [Budget].[DocumentID]
		LEFT JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		INNER JOIN [ProjectDetail]
			ON [ProjectDetail].[ID] = [Budget].[DocumentID]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Budget].[Class] AND
				[Reminder].[DocumentID] = [Budget].[ID] AND
				[Reminder].[Subtype] = 'BC')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[Budget].[ID] = @ID

	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetGet] TO PUBLIC
GO