﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineTimeEntryBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineTimeEntryBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineTimeEntryBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineTimeEntryBrowse'
GO

/******************************************************************************
**		File: BudgetLineTimeEntryBrowse.sql
**		Name: pjm6BudgetLineTimeEntryBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetLineTimeEntryBrowse]
	@BudgetLineID TIdentifier
AS
	SET NOCOUNT ON

	IF	(SELECT
			[BudgetLineWork].[Own]
		FROM 
			[BudgetLineWork]
		WHERE 
			[BudgetLineWork].[ID] = @BudgetLineID
		) = 1
	BEGIN
		SELECT
			[TimeEntry].[Class],
			[TimeEntry].[ID],
			[TimeEntry].[State],
			[TimeEntry].[Flag],
			[TimeEntry].[FileAs],
			[TimeEntry].[ActivityTypeID],
			[TimeEntry].[EmployeeID],
			[TimeEntry].[ProjectID],
			[TimeEntry].[StartTime],
			[TimeEntry].[Duration],
			[TimeEntry].[RoundedDuration],
			[TimeEntry].[Billable],
			[TimeEntry].[BillableDuration],
			[TimeEntry].[Overtime],
			[TimeEntry].[Rate],
			[TimeEntry].[CurrencyCode],
			[TimeEntry].[VATRate],
			CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour] AS [Sum],
			[TimeEntry].[Color],
			[TimeEntry].[Comments],
			[TimeEntry].[Created],
			[TimeEntry].[CreatedBy],
			[TimeEntry].[Modified],
			[TimeEntry].[ModifiedBy],
			[TimeEntry].[Timestamp],
			(CASE
				WHEN [TimeEntry].[TaskID] IS NULL THEN 
				(
					SELECT TOP(1) 
						[DocumentClassName] 
					FROM 
						adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass])
				)
				ELSE 
				(
					SELECT dbo.adfGetDocumentClassNameByTable('Task')
				)
			END) AS [DocumentClassName],
			(CASE
				WHEN [TimeEntry].[TaskID] IS NULL THEN 
				(
					SELECT TOP(1) 
						[DocumentName] 
					FROM 
						adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass])
				)
				ELSE 
				(
					SELECT 
						[Task].[FileAs] 
					FROM 
						[Task] 
					WHERE 
						[Task].[ID] = [TimeEntry].[TaskID]
				)
			END) AS [DocumentName]
		FROM
			[BudgetLineWorkEntries]
			INNER JOIN [vwTimeEntry] as [TimeEntry]
				ON [BudgetLineWorkEntries].[EntryID] = [TimeEntry].[ID]
		WHERE
			[BudgetLineWorkEntries].[BudgetLineID] = @BudgetLineID
	END	
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetLineTimeEntryBrowse] TO PUBLIC
GO
   
