IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkGet'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkGet'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkGet.sql
**		Name: pjm6BudgetLineWorkGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		25.04.11	SYV			  BudgetState
**		21.02.13	MAB			  " "  ""
**		08.08.14	SAP			   DocumentClass
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkGet
	@ID	TIdentifier
	
AS
	SET NOCOUNT ON
	
	DECLARE
		@BudgetClass	TClass,
		@TemplateClass  TClass,
		@Class			TClass,
		@BudgetID		TIdentifier


	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	SET @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget')
	SET @BudgetID = (SELECT [BudgetID] FROM [BudgetLineWork] WHERE [ID] = @ID)
	SET @Class = (SELECT [Class] FROM [Document] WHERE [ID] = @BudgetID AND [Class] = @TemplateClass)

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1 AND dbo.fnPjm6CanViewBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		[BudgetLineWork].[ID],                   
		[BudgetLineWork].[Class],                 
		[BudgetLineWork].[State],                 
		[BudgetLineWork].[Flag],                  
		[BudgetLineWork].[FileAs],                
		[BudgetLineWork].[BudgetID],
		[Budget].[DocumentID] AS [ProjectID],              
		(SELECT TOP(1) [Code] FROM [Class] WHERE [Class] =  [BudgetLineWork].[DocumentClass]) AS [DocumentClass],         
		[BudgetLineWork].[DocumentID],
		CASE WHEN @Class IS NOT NULL THEN @TemplateClass ELSE @BudgetClass END AS [BudgetClass],
		[Budget].[CurrencyCode] AS [ToCurrencyCode],             
		[BudgetLineWork].[BudgetLineGroupID],     
		[BudgetLineWork].[StartDate],             
		[BudgetLineWork].[EndDate],                           
		[BudgetLineWork].[Rate],
		[Budget].[VATRate],
		[Budget].[VATIsIncluded],
		[Budget].[PlanningActivityForWork],
		[Budget].[PlanningEmployeeForWork],
		[Budget].[PlanningQualificationForWork],
		[Budget].[PlanningDateForWork],
		[BudgetLineWork].[EmployeeID],            
		[BudgetLineWork].[ActivityTypeID],        
		[BudgetLineWork].[QualificationID],
		~([BudgetLineWork].[Own]) AS [Own],       
		[BudgetLineWork].[PlannedManHour],        
		[BudgetLineWork].[ActualManHour],         
		[BudgetLineWork].[Comments],              
		[BudgetLineWork].[VATPCPlannedManHour],   
		[BudgetLineWork].[TotalPCPlannedManHour], 
		[BudgetLineWork].[TotalWithVATPCPlannedManHour], 
		[BudgetLineWork].[VATPCActualManHour],    
		[BudgetLineWork].[TotalPCActualManHour],  
		[BudgetLineWork].[TotalWithVATPCActualManHour],
		[BudgetLineWork].[ExpenseID],
		[BudgetLineWork].[Created],               
		[BudgetLineWork].[CreatedBy],             
		[BudgetLineWork].[Modified],              
		[BudgetLineWork].[ModifiedBy],
		[BudgetLineWork].[Timestamp],
		[Budget].[State] AS [BudgetState],
		[BudgetLineWork].[AssignmentID]
	FROM
		[BudgetLineWork]
	INNER JOIN [Budget]
		ON [Budget].[ID] = [BudgetLineWork].[BudgetID]
	WHERE
		[BudgetLineWork].[ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkGet TO PUBLIC
GO