IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseSelectorDialog'
GO

/******************************************************************************
**		File: ServiceBrowseSelectorDialog.sql
**		Name: pjm5CalculationBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.03.11	SYV				    "  "
**		11.08.14	BAO				        
**		18.08.14	BAO				   
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseSelectorDialog]
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@ProjectID TIdentifier,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@State int,
	@IncludingRecordsOfSubprojects bit
AS
	SET NOCOUNT ON
	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@statementClass TClass,
		@invoiceClass TClass,
		@requestClass TClass,
		@factureClass TClass,
		@language TLanguage

	--      
	DECLARE @subprojectsTable TABLE 
	(
		[Class] TClass,
		[ID] TIdentifier,
		[State] TState,
		[Flag] TFlag,
		[Date] TDate,
		[Number] TCode,
		[FileAs] TName,
		[ProjectTypeID] TIdentifier,
		[SupplierCompanyID] TIdentifier,
		[ProjectManagerEmployeeID] TIdentifier,
		[CustomerCompanyID] TIdentifier,
		[CustomerFinanceManagerID] TIdentifier,
		[ResponsiblePersonEmployeeID] TIdentifier,
		[PriorityID] TIdentifier,
		[DueDate] TDate,
		[EndDate] TDate,
		[CurrencyCode] TCode3,
		[CostCenterID] TIdentifier,
		[ManHour] TCount,
		[Budget] TMoney,
		[PlannedManHour] TCount,
		[PlannedBudget] TMoney,
		[Billable] TBool,
		[RoundingInterval] TCount,
		[RoundingMode] TIdentifier,
		[ContractNumber] TCode,
		[ContractDate] TDate,
		[ContractEndDate] TDate,
		[ContractSubject] TName,
		[ServiceLevelID] TIdentifier,
		[ApplyVAT] TBool,
		[InvoiceExpirationPeriod] TCount,
		[InvoiceExpirationPeriodType] TIdentifier,
		[Comments] TNotes,
		[Created] TSysDateTime,
		[CreatedBy] TUserID,
		[Modified] TSysDateTime,
		[ModifiedBy] TUserID,
		[ExchangeSystemName] TName,
		[Timestamp] varbinary(MAX),
		[PercentComplete] TPercent,
		[PC] INT,
		[PaymentCurrencyPoint] TIdentifier,
		[IsConsignor] TBool,
		[Consignor] TName,
		[ConsignorContract] TName,
		[ParentProjectID] INT,
		[ManagerAssistantEmployeeID] TIdentifier,
		[FinanceManagerEmployeeID] TIdentifier
	);

	--     
	INSERT INTO @subprojectsTable exec pjm6SubProjectBrowse @ParentProjectID=@ProjectID,@StateSelector=2,
		@CanCreateCalculation = 1
		
	SET @language = dbo.adfGetLanguage()
		
	SELECT
		@statementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@invoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest'),
		@factureClass = dbo.adfGetClassByName('Pjm5.Facture')
	
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Project].[Number] AS [ProjectCode],
		[Calculation].[State],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE NULL
		END AS [CalculationType],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[Date],
		[Calculation].[CurrencyCode],
		[Calculation].[VATRate],
		[Calculation].[RatesWithVAT] AS [VATIsIncluded],
		
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[VAT],
		[Calculation].[TotalWithVATPC] AS [TotalSumProjectCurrency],
		[Calculation].[StatementApproved], [Calculation].[InvoiceApproved],
		[Calculation].[Comments]
	FROM
		[Calculation]
		INNER JOIN [Project]
				ON [Project].[ID] = [Calculation].[ProjectID]
	WHERE
		[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd AND
		(
			(
				[Calculation].[State] = 2 OR
				[Calculation].[State] = 3 AND 
				(
					(@DocumentClass = @statementClass AND [Calculation].[StatementApproved] = 0)
					OR
					(@DocumentClass = @invoiceClass AND [Calculation].[InvoiceApproved] = 0)
					OR
					(@DocumentClass = @factureClass)
				)
			) AND
			(
				(@DocumentClass = @statementClass AND 
					NOT EXISTS(
						SELECT * FROM [StatementLine] 
						WHERE [StatementLine].[StatementID] = @DocumentID AND 
							[StatementLine].[DocumentClass] = [Calculation].[Class] AND
							[StatementLine].[DocumentID] = [Calculation].[ID]
						)
				)
				OR
				(@DocumentClass = @invoiceClass AND 
					NOT EXISTS(
						SELECT * FROM [InvoiceLine] 
						WHERE [InvoiceLine].[InvoiceID] = @DocumentID AND 
							[InvoiceLine].[DocumentClass] = [Calculation].[Class] AND
							[InvoiceLine].[DocumentID] = [Calculation].[ID]
						)
				)
				OR
				(@DocumentClass = @factureClass)
			)AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[Calculation].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[Calculation].[ProjectID] = @ProjectID
				)
			)
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseSelectorDialog] TO PUBLIC
GO
      