 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardCreate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardCreate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardCreate'
GO

/******************************************************************************
**		File: pjm5DocumentCardCreate.sql
**		Name: pjm5DocumentCardCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		19.02.13	SAP				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardCreate]
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@State TState,
		@doc int
	
	SET @State = dbo.adfwfGetInitialState('6cc877ce-4425-4e49-a3d5-76b01ae709ae')
	IF @State != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@FolderID TIdentifier,
		@FileAs TName,
		@DocumentTypeID TIdentifier,
		@DocumentCardClassID TIdentifier,
		@DocumentCardID TIdentifier,
		@Number TCode,
		@Date TDate,
		@NumberIn TCode,
		@DateIn TDate,
		@NumberOut TCode,
		@DateOut TDate,
		@CompanyID TIdentifier,
		@ContactID TIdentifier,
		@CorrespondentCompanyID TIdentifier,
		@CorrespondentContactID TIdentifier,
		@DivisionID TIdentifier,
		@CaseID TIdentifier,
		@DocumentSendTypeID TIdentifier,
		@SentTime TDateTime,
		@CardOwnerID TIdentifier,
		@HasToBeSentBack TBool,
		@SentBackTime TDateTime,
		@DocumentSendBackTypeID TIdentifier,
		@Comments TNotes

	SELECT
		@FolderID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/FolderID)[1]','int'),
		@FileAs = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/FileAs)[1]','nvarchar(512)'),
		@DocumentCardClassID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentCardClassID)[1]','int'),
		@DocumentCardID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentCardID)[1]','int'),
		@Number = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Number)[1]','varchar(32)'),
		@Date = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/Date)[1]','nvarchar(19)') AS datetime),
		@NumberIn = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/NumberIn)[1]','varchar(32)'),
		@DateIn = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/DateIn)[1]','nvarchar(19)') AS datetime),
		@NumberOut = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/NumberOut)[1]','varchar(32)'),
		@DateOut = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/DateOut)[1]','nvarchar(19)') AS datetime),
		@CompanyID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CompanyID)[1]','int'),
		@ContactID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/ContactID)[1]','int'),
		@CorrespondentCompanyID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CorrespondentCompanyID)[1]','int'),
		@CorrespondentContactID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CorrespondentContactID)[1]','int'),
		@DivisionID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DivisionID)[1]','int'),
		@CaseID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CaseID)[1]','int'),
		@DocumentSendTypeID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentSendTypeID)[1]','int'),
		@SentTime = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/SentTime)[1]','nvarchar(19)') AS datetime),
		@CardOwnerID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CardOwnerID)[1]','int'),
		@HasToBeSentBack = CASE 
								WHEN @Xml.value('(/pjm5DocumentCardGet/DocumentCard/HasToBeSentBack)[1]','varchar(5)') = 'false' THEN 0 
								ELSE 1 
						   END,
		@SentBackTime = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/SentBackTime)[1]','nvarchar(19)') AS datetime),
		@DocumentSendBackTypeID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentSendBackTypeID)[1]','int'),
		@Comments = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Comments)[1]','nvarchar(max)')	 
		

	BEGIN TRANSACTION
	INSERT INTO [DocumentCard]
		([State], 
		[Flag], 
		[FileAs], 
		[FolderID],
		[DocumentCardClassID],
		[DocumentCardID],
		[Number],
		[Date],
		[NumberIn],
		[DateIn],
		[NumberOut],
		[DateOut],
		[CompanyID],
		[ContactID],
		[CorrespondentCompanyID],
		[CorrespondentContactID],
		[DivisionID],
		[CaseID],
		[SentTime],
		[DocumentSendTypeID],
		[CardOwnerID],
		[HasToBeSentBack],
		[SentBackTime],
		[DocumentSendBackTypeID],
		[Comments])
	VALUES
		(@State, 
		0, 
		@FileAs, 
		@FolderID,
		@DocumentCardClassID,
		@DocumentCardID,
		@Number,
		@Date,
		@NumberIn,
		@DateIn,
		@NumberOut,
		@DateOut,
		@CompanyID,
		@ContactID,
		@CorrespondentCompanyID,
		@CorrespondentContactID,
		@DivisionID,
		@CaseID,
		@SentTime,
		@DocumentSendTypeID,
		@CardOwnerID,
		@HasToBeSentBack,
		@SentBackTime,
		@DocumentSendBackTypeID,
		@Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	COMMIT TRANSACTION
	EXEC pjm5DocumentCardGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentCreate'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentCreate]
	END
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentCreate'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentCreate]
	END
GO

