IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassBrowse'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassBrowse]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassBrowse'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassBrowse.sql
**		Name: pjm5DocumentCardClassBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardClassBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[DocumentCardClass].[Class],
		[DocumentCardClass].[ID],
		[DocumentCardClass].[State],
		[DocumentCardClass].[Flag],
		[DocumentCardClass].[Code],
		[DocumentCardClass].[FileAs],
		[DocumentCardClass].[Comments],
		[DocumentCardClass].[Created],
		[DocumentCardClass].[CreatedBy],
		[DocumentCardClass].[Modified],
		[DocumentCardClass].[ModifiedBy],
		[DocumentCardClass].[Timestamp]
	FROM
		[DocumentCardClass]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [DocumentCardClass].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [DocumentCardClass].[State] = 2)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentCardClassBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassGet'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassGet]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassGet'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassGet.sql
**		Name: pjm5DocumentCardClassGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardClassGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[DocumentCardClass].[Class],
		[DocumentCardClass].[ID],
		[DocumentCardClass].[State],
		[DocumentCardClass].[Flag],
		[DocumentCardClass].[Code],
		[DocumentCardClass].[FileAs],
		[DocumentCardClass].[Comments],
		[DocumentCardClass].[Created],
		[DocumentCardClass].[CreatedBy],
		[DocumentCardClass].[Modified],
		[DocumentCardClass].[ModifiedBy],
		[DocumentCardClass].[Timestamp]
	FROM
		[DocumentCardClass]
	WHERE
		[DocumentCardClass].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentCardClassGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassCreate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassCreate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassCreate'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassCreate.sql
**		Name: pjm5DocumentCardClassCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		01.12.09	SPV				 GUID  UOM  DocumentCardClass
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardClassCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('B3971E27-4BC4-4971-A0A1-41731E7948C5')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [DocumentCardClass]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5DocumentCardClassGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardClassCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassUpdate.sql
**		Name: pjm5DocumentCardClassUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardClassUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[DocumentCardClass]
	SET
		[DocumentCardClass].[Code] = @Code,
		[DocumentCardClass].[FileAs] = @FileAs,
		[DocumentCardClass].[Comments] = @Comments,
		[DocumentCardClass].[Modified] = DEFAULT,
		[DocumentCardClass].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentCardClass].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5DocumentCardClassGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardClassUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassDelete'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassDelete.sql
**		Name: pjm5DocumentCardClassDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardClassDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [DocumentCardClass] WHERE [DocumentCardClass].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardClassDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardClassChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardClassChangeState'
		DROP PROCEDURE [dbo].[pjm5DocumentCardClassChangeState]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardClassChangeState'
GO

/******************************************************************************
**		File: pjm5DocumentCardClassChangeState.sql
**		Name: pjm5DocumentCardClassChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardClassChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [DocumentCardClass].[Class],
		@FromState = [DocumentCardClass].[State]
	FROM
		[DocumentCardClass]
	WHERE
		[DocumentCardClass].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[DocumentCardClass]
	SET
		[DocumentCardClass].[State] = @ToState,
		[DocumentCardClass].[Modified] = DEFAULT,
		[DocumentCardClass].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentCardClass].[ID] = @ID
	AND
		[DocumentCardClass].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardClassChangeState TO PUBLIC
GO
