IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseDelete'
		DROP PROCEDURE [dbo].[pjm5ExpenseDelete]
	END
GO

PRINT 'Creating procedure pjm5ExpenseDelete'
GO

/******************************************************************************
**		File: pjm5ExpenseDelete.sql
**		Name: pjm5ExpenseDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@projectManager TBool,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@TimeEntryClass TClass,
		@ExpenseClass TClass,
		@ExpenseSecretary TBool
	
	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')
	SELECT 
		@ExpenseClass = [Class],
		@EmployeeID = [EmployeeID], 
		@ProjectID = [ProjectID],
		@projectManager = dbo.fnPjm5IsProjectManager([ProjectID] , @CurrentEmployeeID)
	FROM 
		[Expense] 
	WHERE 
		[Expense].[ID] = @ID

	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @EmployeeID) = 0 AND @ExpenseSecretary = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @class TClass
	SET @class = dbo.adfGetClassByName('Pjm5.Expense')
	BEGIN TRANSACTION
	DELETE FROM [DocumentCategory] WHERE [DocumentClass] = @class AND [DocumentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [DocumentContact] WHERE [DocumentClass] = @class AND [DocumentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [PhoneCall] WHERE [PhoneCall].[ExpenseID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#CannotDeletePhoneCall', 18, -1)
		RETURN 1
	END
	
	DELETE FROM [Attachment] 
	WHERE 
		[Attachment].[DocumentClass] = @TimeEntryClass AND
		[Attachment].[LinkDocumentClass] = @ExpenseClass AND 
		[Attachment].[LinkDocumentID] = @ID AND
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	

	DELETE FROM [Expense] WHERE [Expense].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseDelete TO PUBLIC
GO
 