 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6GetLastExport1C]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6GetLastExport1C'
		DROP PROCEDURE [dbo].[pjm6GetLastExport1C]
	END
GO

PRINT 'Creating procedure pjm6GetLastExport1C'
GO

/******************************************************************************
**		File: pjm6GetLastExchange1C.sql
**		Name: pjm6GetLastExchange1C
**		Desc:          
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: olga.kuznetsova
**		Date: 30/04/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		----------	------------	-------------------------------------------
**		30/04/2010	KOV				first version
**		22/06/2010	SPV				changed source of data (Now from ExportItem)
**		
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6GetLastExport1C]
	@SupplierID TIdentifier,
	@EmployeeID TIdentifier OUTPUT, 
	@DataLastExport TDate OUTPUT
AS
		
	SELECT TOP(1)
		@EmployeeID = [ExportItem].[EmployeeID],
		@DataLastExport = [ExportItem].[Date]
	FROM
		[ExportItem]
	WHERE
		[CompanyID] = @SupplierID
	ORDER BY
		[Date] DESC
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6GetLastExport1C TO PUBLIC
GO
