IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FavoriteFolderBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FavoriteFolderBrowse'
		DROP PROCEDURE [dbo].[pjm5FavoriteFolderBrowse]
	END
GO

PRINT 'Creating procedure pjm5FavoriteFolderBrowse'
GO

/******************************************************************************
**		File: pjm5FavoriteFolderBrowse.sql
**		Name: pjm5FavoriteFolderBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      27.06.11	SPV				Optimization
*******************************************************************************/
CREATE PROCEDURE [pjm5FavoriteFolderBrowse]
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SELECT
		[UserFavoriteFolder].[FolderID],
		[UserFavoriteFolder].[FileAs],
		[UserFavoriteFolder].[AddSubfolders] AS [ShowSubfoldersFlag]
	FROM
		[UserFavoriteFolder]
	WHERE
		[UserID] = @UserID
	IF @@error != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FavoriteFolderBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FavoriteFolderUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FavoriteFolderUpdate'
		DROP PROCEDURE [dbo].[pjm5FavoriteFolderUpdate]
	END
GO

PRINT 'Creating procedure pjm5FavoriteFolderUpdate'
GO

/******************************************************************************
**		File: pjm5FavoriteFolderUpdate.sql
**		Name: pjm5FavoriteFolderUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FavoriteFolderUpdate]
	@ID TIdentifier,
	@FileAs TName
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [UserFavoriteFolder] WHERE [UserID] = @UserID AND [FileAs] = @FileAs AND [FolderID] != ISNULL(@ID, -1))
	BEGIN
		RAISERROR('#folderalreadyexists', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION
	UPDATE 
		[UserFavoriteFolder]
	SET
		[FileAs] = @FileAs
	WHERE
		[FolderID] = @ID AND [UserID] = @UserID
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FavoriteFolderUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FavoriteFolderAppend]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FavoriteFolderAppend'
		DROP PROCEDURE [dbo].[pjm5FavoriteFolderAppend]
	END
GO

PRINT 'Creating procedure pjm5FavoriteFolderAppend'
GO

/******************************************************************************
**		File: pjm5FavoriteFolderAppend.sql
**		Name: pjm5FavoriteFolderAppend
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FavoriteFolderAppend]
	@ID TIdentifier,
	@FileAs TName,
	@Flag int
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [UserFavoriteFolder] WHERE [UserID] = @UserID AND [FileAs] = @FileAs AND [FolderID] != @ID)
	BEGIN
		RAISERROR('#folderalreadyexists', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION	
	IF EXISTS (SELECT * FROM [UserFavoriteFolder] WHERE [UserID] = @UserID AND [FolderID] = @ID)
	BEGIN
		UPDATE 
			[UserFavoriteFolder]
		SET
			[FileAs] = @FileAs,
			[AddSubfolders] = @Flag
		WHERE
			[FolderID] = @ID AND [UserID] = @UserID	
	END
	ELSE
	BEGIN
		INSERT INTO [UserFavoriteFolder] 
			([UserID], [FolderID], [FileAs], [AddSubfolders])
		VALUES
			(@UserID, @ID, @FileAs, @Flag)
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FavoriteFolderAppend] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FavoriteFolderRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FavoriteFolderRemove'
		DROP PROCEDURE [dbo].[pjm5FavoriteFolderRemove]
	END
GO

PRINT 'Creating procedure pjm5FavoriteFolderRemove'
GO

/******************************************************************************
**		File: pjm5FavoriteFolderRemove.sql
**		Name: pjm5FavoriteFolderRemove
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FavoriteFolderRemove]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	DELETE FROM [UserFavoriteFolder] WHERE [FolderID] = @ID AND [UserID] = @UserID
	IF @@error != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FavoriteFolderRemove] TO PUBLIC
GO
