IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderAccessUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderAccessUpdate'
		DROP PROCEDURE [dbo].[pjm5FolderAccessUpdate]
	END
GO

PRINT 'Creating procedure pjm5FolderAccessUpdate'
GO

/******************************************************************************
**		File: pjm5FolderAccessUpdate.sql
**		Name: pjm5FolderAccessUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderAccessUpdate]
	@FolderID TIdentifier,
	@TrusteeID TIdentifier,
	@AccessRights TBitMask
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderOwner') = 0 AND
		dbo.adfHasAccessRight(dbo.adfGetRightID('TakeOwnership')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [FolderAccessControl] WHERE [FolderID] = @FolderID AND [TrusteeID] = @TrusteeID)
	BEGIN
		UPDATE 
			[FolderAccessControl]
		SET 
			[AccessRights] = @AccessRights
		WHERE
			[FolderID] = @FolderID AND 
			[TrusteeID] = @TrusteeID
		IF @@ERROR != 0
			RETURN 1
	END
	ELSE
	BEGIN
		INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
		VALUES(@FolderID, @TrusteeID, @AccessRights)
		IF @@ERROR != 0
			RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderAccessUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderAccessDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderAccessDelete'
		DROP PROCEDURE [dbo].[pjm5FolderAccessDelete]
	END
GO

PRINT 'Creating procedure pjm5FolderAccessDelete'
GO

/******************************************************************************
**		File: pjm5FolderAccessDelete.sql
**		Name: pjm5FolderAccessDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderAccessDelete]
	@FolderID TIdentifier,
	@TrusteeID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderOwner') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DELETE FROM [FolderAccessControl] WHERE [FolderID] = @FolderID AND [TrusteeID] = @TrusteeID
	IF @@ERROR != 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderAccessDelete] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderAccessApplyToSubfolders]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderAccessApplyToSubfolders'
		DROP PROCEDURE [dbo].[pjm5FolderAccessApplyToSubfolders]
	END
GO

PRINT 'Creating procedure pjm5FolderAccessApplyToSubfolders'
GO

/******************************************************************************
**		File: pjm5FolderAccessApplyToSubfolders.sql
**		Name: pjm5FolderAccessApplyToSubfolders
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderAccessApplyToSubfolders]
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderOwner') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	;WITH [Folders] ([FolderID], [ID], [Level]) AS
	(
		SELECT [FolderID], [ID], 0 FROM [Folder] WHERE [FolderID] = @FolderID
		UNION ALL
		SELECT [Folder].[FolderID], [Folder].[ID], [Folders].[Level] + 1
		FROM
			[Folder]
			INNER JOIN [Folders]
				ON [Folders].[ID] = [Folder].[FolderID]
	)
	DELETE 
		[FolderAccessControl] 
	FROM 
		[FolderAccessControl]
		INNER JOIN [Folders]
			ON [Folders].[ID] = [FolderAccessControl].[FolderID]
			
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	;WITH [Folders] ([FolderID], [ID], [Level]) AS
	(
		SELECT [FolderID], [ID], 0 FROM [Folder] WHERE [FolderID] = @FolderID
		UNION ALL
		SELECT @FolderID, [Folder].[ID], [Folders].[Level] + 1
		FROM
			[Folder]
			INNER JOIN [Folders]
				ON [Folders].[ID] = [Folder].[FolderID]
	)
	INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
	SELECT
		[Folders].[ID], [FolderAccessControl].[TrusteeID], [FolderAccessControl].[AccessRights]
	FROM 
		[Folders]
		INNER JOIN [FolderAccessControl]
			ON [FolderAccessControl].[FolderID] = [Folders].[FolderID]
			
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderAccessApplyToSubfolders] TO PUBLIC
GO