IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderCreate'
		DROP PROCEDURE [dbo].[pjm5FolderCreate]
	END
GO

PRINT 'Creating procedure pjm5FolderCreate'
GO

/******************************************************************************
**		File: pjm5FolderCreate.sql
**		Name: pjm5FolderCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderCreate]
	@FolderID TIdentifier, 
	@FileAs TName
AS
	SET NOCOUNT ON
	DECLARE 
		@ID TIdentifier,
		@State TState,
		@CompanyID TIdentifier,
		@VersionControl TBool,
		@PublicationControl TBool,
		@Parameters xml,
		@UserID TIdentifier,
		@FileTemplate TName
	
	SET @State = dbo.adfwfGetInitialState('be2f5d0b-64aa-497f-b761-fff3e7394e02')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
		
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateSubfolder') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT 
		@CompanyID = [CompanyID],
		@VersionControl = [VersionControl],
		@PublicationControl = [PublicationControl],
		@Parameters = [Parameters],
		@FileTemplate = [FileTemplate]
	FROM 
		[Folder]
	WHERE 
		[ID] = @FolderID

	BEGIN TRANSACTION
	INSERT INTO [Folder]
		([State], [Flag], [CompanyID], [FolderID], [FileAs], [VersionControl], [PublicationControl], [Parameters], [FileTemplate])
	VALUES
		(@State, 0, @CompanyID, @FolderID, @FileAs, @VersionControl, @PublicationControl, @Parameters, @FileTemplate)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
	SELECT 
		@ID, [TrusteeID], [AccessRights]
	FROM
		[FolderAccessControl]
	WHERE
		[FolderID] = @FolderID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed], [MandatoryFields], [DefaultValues])
	SELECT
		@ID, 
		[CaseOfFolder].[CaseID], 
		CASE [Case].[State] WHEN 1 THEN [CaseOfFolder].[Allowed] ELSE 0 END, 
		[CaseOfFolder].[MandatoryFields], [CaseOfFolder].[DefaultValues]
	FROM
		[CaseOfFolder]
		INNER JOIN [Case]
			ON [Case].[ID] = [CaseOfFolder].[CaseID]
	WHERE
		[CaseOfFolder].[FolderID] = @FolderID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [FolderNotificationSettings]
		([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
	SELECT
		@ID, [TrusteeID], [FolderSettings], [CardSettings], [FileSettings]
	FROM
		[FolderNotificationSettings]
	WHERE
		[FolderNotificationSettings].[FolderID] = @FolderID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC pjm5FolderCreateSubfolderNotification @ID
	COMMIT TRANSACTION
	EXEC pjm5FolderGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5FolderCreate TO PUBLIC
GO
 