IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrInvoiceUpdate')
	BEGIN
		PRINT 'Dropping Trigger adftrInvoiceUpdate'
		DROP  Trigger adftrInvoiceUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrInvoiceUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrInvoiceUpdate'
GO
CREATE TRIGGER [adftrInvoiceUpdate] 
ON [Invoice] FOR UPDATE
AS
BEGIN
    IF @@rowcount = 0
       RETURN

    SET NOCOUNT ON
	
	IF NOT (UPDATE([ExchangeBanned]) OR UPDATE([ExportItemID]))
	BEGIN
		UPDATE [Document] 
		SET
			[State] = [inserted].[State], 
			[Flag] = [inserted].[Flag], 
			[FileAs] = [inserted].[FileAs], 
			[Modified] = [inserted].[Modified], 
			[ModifiedBy] = [inserted].[ModifiedBy], 
			[Timestamp] = [inserted].[Timestamp]
		FROM
			[Document] INNER JOIN [inserted]
				ON ([Document].[ID] = [inserted].[ID] AND [Document].[Class] = [inserted].[Class])
    END
    
    RETURN
END
GO
