IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueDraftAllBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueDraftAllBrowse'
		DROP PROCEDURE [dbo].[pjm5IssueDraftAllBrowse]
	END
GO

PRINT 'Creating procedure pjm5IssueDraftAllBrowse'
GO

/******************************************************************************
**		File: pjm5IssueDraftBrowse.sql
**		Name: pjm5IssueDraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueDraftAllBrowse]
	@ProjectID INT
AS

	SET NOCOUNT ON
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE	@UserID int
	SET	@UserID = dbo.adfGetCurrentUserID()
	
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	DECLARE @IssueClass TClass
	SET @IssueClass = dbo.adfGetClassByName('Pjm5.Issue')
	
	SELECT
		[Issue].[Class],
		[Issue].[ID],
		[Issue].[State],
		[Issue].[Flag],
		[Issue].[Number],
		[Issue].[FileAs],
		[Issue].[DuplicateOfIssueID],
		[Issue].[ProjectID],
		[Issue].[EmployeeID],
		[Issue].[SeverityID],
		[Issue].[PriorityID],
		[Issue].[DueDate],
		[Issue].[EndTime],
		[Issue].[ResolutionID],
		[Issue].[Resolution],
		[Issue].[SendStatusReport],
		[Issue].[WSSDocumentURL],
		[Issue].[UDF1],
		[Issue].[UDF2],
		[Issue].[UDF3],
		[Issue].[UDF4],
		[Issue].[Comments],
		[Issue].[Created],
		[Issue].[CreatedBy],
		[Issue].[Modified],
		[Issue].[ModifiedBy],
		[Issue].[Timestamp],
		CAST(ISNULL([DocumentUserState].[Read], 0) as bit) as [Read],
		[DocumentUserState].[ReadTime],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[ActualBudget]
			ELSE -1
		END AS [ActualBudget],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[Budget]
			ELSE -1
		END AS [Budget],
		[Issue].[ActualManHour],
		[Issue].[ManHour]
	FROM
		[Issue]
		INNER JOIN [Project] ON [Project].[ID] = [Issue].[ProjectID]
		LEFT OUTER JOIN [DocumentUserState]
			ON ([DocumentUserState].[UserID] = @UserID AND 
				[DocumentUserState].[DocumentClass] = @IssueClass AND 
				[DocumentUserState].[DocumentID] = [Issue].[ID])
	WHERE
		[Issue].[State] = 1 
	AND 
		(
			(@ProjectID > 0 AND [Issue].[ProjectID] = @ProjectID)
			OR 
			(@ProjectID = -1 AND [Issue].[ProjectID] IN (SELECT [ProjectID] FROM [IssueProject] WHERE [UserID] = @userId))
			OR
			(@ProjectID = -2 AND [Issue].[ProjectID] IN (SELECT [ID] FROM [Project]	WHERE
				[State] = 2 AND [Project].[SupportsRequestManagement] != 0
				AND
				([ProjectManagerEmployeeID] = @EmployeeID OR  
				dbo.fnPjm5IsProjectMember([Project].[ID], @EmployeeID) = 1 OR
				dbo.fnPjm5IsAssistant() = 1)))			
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5IssueDraftAllBrowse] TO PUBLIC
GO
 
