IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'IssueUDFListBrowse')
	BEGIN
		PRINT 'Dropping Procedure IssueUDFListBrowse'
		DROP  Procedure  IssueUDFListBrowse
	END

GO

PRINT 'Creating Procedure IssueUDFListBrowse'
GO
/******************************************************************************
**		File: 
**		Name: IssueUDFListBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure IssueUDFListBrowse
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3Caption],
		(SELECT [UDFCaption] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4Caption],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3SortOrder],
		(SELECT [SortOrderAscending] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4SortOrder],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=1) as [UDF1List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=2) as [UDF2List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=3) as [UDF3List],
		(SELECT [NamedListID] FROM [NamedListBinding] INNER JOIN [NamedList] ON ([NamedListBinding].[NamedListID] = [NamedList].[ID]) WHERE [NamedList].[ProjectID] = @ProjectID AND [NamedListBinding].[UDFIndex]=4) as [UDF4List]

	SELECT
		[NamedListID],
		[Code]
	FROM
		[NamedListEntry]
	WHERE
		[NamedListID] IN (SELECT [ID] FROM [NamedList] WHERE [ProjectID] = @ProjectID)

	RETURN 0
GO

GRANT EXEC ON IssueUDFListBrowse TO PUBLIC
GO
