IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfLicensePlace]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfLicensePlace'
		DROP PROCEDURE [dbo].[adfLicensePlace]
	END
GO

PRINT 'Creating procedure adfLicensePlace'
GO

/******************************************************************************
**		File: adfLicensePlace.sql
**		Name: adfLicensePlace
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		.
*******************************************************************************/
CREATE PROCEDURE [adfLicensePlace]
	@UserID TIdentifier,
	@LicenseID TIdentifier
AS
	IF @UserID IS NULL
		SET @UserID = dbo.adfGetCurrentUserID()

	UPDATE [License]
	SET [UserID] = @UserID
	WHERE [ID] = @LicenseID

	RETURN 0
GO

GRANT EXECUTE ON adfLicensePlace TO PUBLIC
GO
 