 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmActiveServiceAssignment')
	BEGIN
		PRINT 'Dropping Procedure lmActiveServiceAssignment'
		DROP  Procedure  lmActiveServiceAssignment
	END

GO

PRINT 'Creating Procedure lmActiveServiceAssignment'
GO
/******************************************************************************
**		File: 
**		Name: lmActiveServiceAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmActiveServiceAssignment
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT
		[ServiceAssignment].[ID],
		[ServiceAssignment].[ProjectID],
		[ServiceAssignment].[FileAs] AS [Name],
		[ServiceAssignment].[State],
		[Service].[Code],
		[Service].[PaymentTermID]
	FROM
		[Service] 
		INNER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[ServiceID] = [Service].[ID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
	WHERE
		[ServiceAssignment].[State] = 1  AND
		[ServiceAssignment].[ProjectID] IN 
			(SELECT [ProjectID] FROM [vwAssignment] WHERE [EmployeeID] = @EmployeeID)
			
	RETURN 0
GO

GRANT EXEC ON lmActiveServiceAssignment TO PUBLIC
GO
 