IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmActivityTypeDefaults')
	BEGIN
		PRINT 'Dropping Procedure lmActivityTypeDefaults'
		DROP  Procedure  lmActivityTypeDefaults
	END

GO

PRINT 'Creating Procedure lmActivityTypeDefaults'
GO
/******************************************************************************
**		File: 
**		Name: lmProjectActivityType
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.04.11	SPV				    
**									 .
**									 JOIN   pjm6GetAvailableProjectsForBrowse.
**									      .
*******************************************************************************/
CREATE Procedure lmActivityTypeDefaults
AS
	SET NOCOUNT ON

	DECLARE @IsAssistant TBool
	SET @IsAssistant = dbo.fnPjm5IsAssistant()	

	SELECT DISTINCT
		[ActivityTypeDefaults].[ActivityTypeID],
		[ActivityTypeDefaults].[Subject],
		[ActivityTypeDefaults].[Comments],
		[ActivityTypeDefaults].[LanguageCode]
	FROM
		[ActivityTypeDefaults]
		INNER JOIN [ProjectActivityType]
			ON [ActivityTypeDefaults].[ActivityTypeID] = [ProjectActivityType].[ActivityTypeID]
	WHERE
		[ProjectActivityType].[Actively] = 1 AND 
		([ProjectActivityType].[ProjectID] IN (SELECT [ID] FROM dbo.fnPjm6GetAvailableProjectsForProjectMemberAndManager())
		 OR @IsAssistant = 1)
	
	RETURN 0
GO

GRANT EXEC ON lmActivityTypeDefaults TO PUBLIC
GO
 