IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmAssignment')
	BEGIN
		PRINT 'Dropping Procedure lmAssignment'
		DROP  Procedure  lmAssignment
	END

GO

PRINT 'Creating Procedure lmAssignment'
GO
/******************************************************************************
**		File: 
**		Name: lmAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmAssignment
AS
	SET NOCOUNT ON
		
	SELECT
		[Assignment].[ID],
		[Assignment].[ProjectID] as [ProjectID],
		[Assignment].[EmployeeID] as [EmployeeID],
		[Project].[Number] as [ProjectCode],
		[Project].[FileAs] as [ProjectName],
		[Assignment].[State],
		[Assignment].[FileAs] AS [Name]
	FROM
		[vwAssignment] AS [Assignment] 
		INNER JOIN [Project]
			ON ([Assignment].[ProjectID] = [Project].[ID])
	
	RETURN 0
GO

GRANT EXEC ON lmAssignment TO PUBLIC
GO
