IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmExpenseCodePrice')
	BEGIN
		PRINT 'Dropping Procedure lmExpenseCodePrice'
		DROP  Procedure  lmExpenseCodePrice
	END

GO

PRINT 'Creating Procedure lmExpenseCodePrice'
GO
/******************************************************************************
**		File: 
**		Name: lmExpenseCodePrice
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.04.11	SPV				    
**									 .
**									 JOIN   
**									pjm6GetAvailableProjectsForBrowse.
*******************************************************************************/
CREATE Procedure lmExpenseCodePrice
AS
	SET NOCOUNT ON

	DECLARE @IsAssistant TBool
	SET @IsAssistant = dbo.fnPjm5IsAssistant()	
		
	SELECT DISTINCT
		[ProjectExpenseCode].[ExpenseCodeID],
		[ExpenseCodePrice].[Price],
		[ExpenseCodePrice].[CurrencyCode]
	FROM
		[ProjectExpenseCode]
		INNER JOIN [ExpenseCodePrice]
			ON [ExpenseCodePrice].[ID] = [ProjectExpenseCode].[ExpenseCodeID]
		INNER JOIN [ExpenseCode]
			ON [ExpenseCode].[ID] = [ProjectExpenseCode].[ExpenseCodeID]
	WHERE
		[ProjectExpenseCode].[Actively] = 1 AND 
		([ProjectExpenseCode].[ProjectID] IN (SELECT [ID] FROM dbo.fnPjm6GetAvailableProjectsForProjectMemberAndManager()) OR @IsAssistant = 1)
	RETURN 0
GO

GRANT EXEC ON lmExpenseCodePrice TO PUBLIC
GO
 