IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmNotificationWay')
	BEGIN
		PRINT 'Dropping Procedure lmNotificationWay'
		DROP  Procedure  lmNotificationWay
	END

GO

PRINT 'Creating Procedure lmNotificationWay'
GO
/******************************************************************************
**		File: 
**		Name: lmNotificationWay
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmNotificationWay
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[NotificationWay].[ID],
		ISNULL([NotificationWayGlobal].[FileAs], [NotificationWay].[FileAs]) AS [FileAs]
	FROM
		[NotificationWay]
		LEFT OUTER JOIN [NotificationWayGlobal]
				ON ([NotificationWay].[ID] = [NotificationWayGlobal].[ID]
					AND [NotificationWayGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON lmNotificationWay TO PUBLIC
GO
 