IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmOwnProjects')
	BEGIN
		PRINT 'Dropping Procedure lmOwnProjects'
		DROP  Procedure  lmOwnProjects
	END

GO

PRINT 'Creating Procedure lmOwnProjects'
GO
/******************************************************************************
**		File: 
**		Name: lmOwnProjects
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.04.11	SPV				     
**									   
*******************************************************************************/
CREATE Procedure lmOwnProjects
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier, @IsAssistant TBool
	SET @IsAssistant = dbo.fnPjm5IsAssistant()

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT
		[ID],
		[Number] as [Code],
		[FileAs] as [Name],
		[State],
		[SupportsRequestManagement]
	FROM
		[Project]
	WHERE
		[Project].[ID] IN (SELECT [ID] FROM dbo.fnPjm6GetAvailableProjectsForProjectMemberAndManager()) OR
		@IsAssistant = 1
	
	RETURN 0
GO

GRANT EXEC ON lmOwnProjects TO PUBLIC
GO
 