IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7NormGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7NormGet'
		DROP PROCEDURE [dbo].[pjm7NormGet]
	END
GO

PRINT 'Creating procedure pjm7NormGet'
GO

/******************************************************************************
**		File: pjm7NormGet.sql
**		Name: pjm7NormGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Avgusta.Bekhtina
**		Date: 19/06/2014 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.08.14	BAO				  ""
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7NormGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Norm].[Class],
		[Norm].[ID],
		[Norm].[State],
		[Norm].[Flag],
		[Norm].[Code],
		[Norm].[FileAs],
		[Norm].[Comments],
		[Norm].[Created],
		[Norm].[CreatedBy],
		[Norm].[Modified],
		[Norm].[ModifiedBy],
		[Norm].[Timestamp],
		[dbo].[fnPjm5GetBaseCurrency]() as [BaseCurrency]
	FROM
		[Norm]
	WHERE
		[Norm].[ID] = @ID
	

	
	DECLARE @BaseCurrency nvarchar(30)
	
	SELECT TOP(1)
		@BaseCurrency = CONVERT(nvarchar(30), [Value])
	FROM
		[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
	WHERE 
		[Name] = 'BaseCurrency'


	SELECT
		DATEPART(year, [NormValue].[Year]) as [Year],
		[NormValue].[UtilizationHours] as [UtilizationHours],
		[NormValue].[RealizationHours] as [RealizationHours],
		CAST((CAST([NormValue].[RealizationHours] as decimal(18,4)) / [NormValue].[UtilizationHours]) as decimal(18,4)) * 100 as [RealizationPercent],
		[NormValue].[Revenue],
		ROUND([NormValue].[Revenue] / CAST([NormValue].[RealizationHours] as decimal(18,4)), 3) as [Rate]
	FROM
		[NormValue]
	WHERE
		[NormValue].[NormID] = @ID
	ORDER BY [Year] DESC

	RETURN 0
GO

GRANT EXECUTE ON [pjm7NormGet] TO PUBLIC
GO