﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7BudgetReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7BudgetReminderCreate'
		DROP PROCEDURE [dbo].[pjm7BudgetReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7BudgetReminderCreate'
GO

/******************************************************************************
**		File: pjm7BudgetReminderCreate.sql
**		Name: pjm7BudgetReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 28.04.2012 15:56:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7BudgetReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv						int
	
	SET @Lang = dbo.adfGetLanguage()
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = 'BC'
		AND
		[Language] = @Lang
			
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm6.Budget')
		
	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												'BC',
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7BudgetReminderCreate] TO PUBLIC
GO     