IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7InvoiceReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7InvoiceReminderCreate'
		DROP PROCEDURE [dbo].[pjm7InvoiceReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7InvoiceReminderCreate'
GO

/******************************************************************************
**		File: pjm7InvoiceReminderCreate.sql
**		Name: pjm7InvoiceReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov	
**		Date: 02.05.2012 14:35:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7InvoiceReminderCreate]
	@DocumentID TIdentifier,
	@Subtype TCode2,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv						int
		
	SET @ReminderEventTime = CAST(CONVERT(varchar(10), @ReminderEventTime, 112) as datetime)
	SET @Lang = dbo.adfGetLanguage()	
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.Invoice')
	
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = @Subtype
		AND
		[Language] = @Lang
	
		
	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												@Subtype,
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7InvoiceReminderCreate] TO PUBLIC
GO    