/*============================================================*/
/* Function:       */
/*============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetLocalSimpleTheme]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetLocalSimpleTheme]
go

create function fnPjm5GetLocalSimpleTheme (@TemplateID TIdentifier, @Lang TLanguage)
returns TName
as
begin
	DECLARE @Message TName
	
	IF @Lang IS NULL
	BEGIN
		SET @Lang = dbo.adfGetLanguage()
	END
	
	SELECT @Message = ISNULL([NotificationMessageTemplateGlobal].[SimpleMessageTheme],
		[NotificationMessageTemplate].[SimpleMessageTheme])
	FROM
		[NotificationMessageTemplate]
		LEFT OUTER JOIN [NotificationMessageTemplateGlobal]
				ON ([NotificationMessageTemplate].[ID] = [NotificationMessageTemplateGlobal].[ID]
					AND [NotificationMessageTemplateGlobal].[Language] = @Lang)
	WHERE
		[NotificationMessageTemplate].[ID] = @TemplateID
	
	RETURN @Message
end
go

grant execute on [dbo].[fnPjm5GetLocalSimpleTheme] to [public]
go

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetLocalSimpleBody]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetLocalSimpleBody]
go

create function fnPjm5GetLocalSimpleBody (@TemplateID TIdentifier, @Lang TLanguage)
returns TNotes
as
begin
	DECLARE @Message TNotes
	
	IF @Lang IS NULL
	BEGIN
		SET @Lang = dbo.adfGetLanguage()
	END
	
	SELECT @Message = ISNULL([NotificationMessageTemplateGlobal].[SimpleMessageBody],
		[NotificationMessageTemplate].[SimpleMessageBody])
	FROM
		[NotificationMessageTemplate]
		LEFT OUTER JOIN [NotificationMessageTemplateGlobal]
				ON ([NotificationMessageTemplate].[ID] = [NotificationMessageTemplateGlobal].[ID]
					AND [NotificationMessageTemplateGlobal].[Language] = @Lang)
	WHERE
		[NotificationMessageTemplate].[ID] = @TemplateID
	
	RETURN @Message
end
go

grant execute on [dbo].[fnPjm5GetLocalSimpleBody] to [public]
go

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetLocalAggregatedTheme]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetLocalAggregatedTheme]
go

create function fnPjm5GetLocalAggregatedTheme (@TemplateID TIdentifier, @Lang TLanguage)
returns TName
as
begin
	DECLARE @Message TName
	
	IF @Lang IS NULL
	BEGIN
		SET @Lang = dbo.adfGetLanguage()
	END
	
	SELECT @Message = ISNULL([NotificationMessageTemplateGlobal].[AggregatedMessageTheme],
		[NotificationMessageTemplate].[AggregatedMessageTheme])
	FROM
		[NotificationMessageTemplate]
		LEFT OUTER JOIN [NotificationMessageTemplateGlobal]
				ON ([NotificationMessageTemplate].[ID] = [NotificationMessageTemplateGlobal].[ID]
					AND [NotificationMessageTemplateGlobal].[Language] = @Lang)
	WHERE
		[NotificationMessageTemplate].[ID] = @TemplateID
	
	RETURN @Message
end
go

grant execute on [dbo].[fnPjm5GetLocalAggregatedTheme] to [public]
go

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetLocalAggregatedBody]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetLocalAggregatedBody]
go

create function fnPjm5GetLocalAggregatedBody (@TemplateID TIdentifier, @Lang TLanguage)
returns TNotes
as
begin
	DECLARE @Message TNotes
	
	IF @Lang IS NULL
	BEGIN
		SET @Lang = dbo.adfGetLanguage()
	END
	
	SELECT @Message = ISNULL([NotificationMessageTemplateGlobal].[AggregatedMessageBody],
		[NotificationMessageTemplate].[AggregatedMessageBody])
	FROM
		[NotificationMessageTemplate]
		LEFT OUTER JOIN [NotificationMessageTemplateGlobal]
				ON ([NotificationMessageTemplate].[ID] = [NotificationMessageTemplateGlobal].[ID]
					AND [NotificationMessageTemplateGlobal].[Language] = @Lang)
	WHERE
		[NotificationMessageTemplate].[ID] = @TemplateID
	
	RETURN @Message
end
go

grant execute on [dbo].[fnPjm5GetLocalAggregatedBody] to [public]
go

/*========================================================================*/
/* Function:     email     */
/*========================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetEmployeeLanguage]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetEmployeeLanguage]
go

create function fnPjm5GetEmployeeLanguage
(@EmployeeID TIdentifier, @DefaultLang TLanguage, @ExternalInitiator TBool)
returns TLanguage
as
begin
	DECLARE @Lang TLanguage, @Class TClass
	IF @EmployeeID IS NULL-- OR @ExternalInitiator = 1
	BEGIN
		SET @Lang = @DefaultLang
		RETURN @Lang
	END
	
	SET @Class = dbo.adfGetClassByName('Adf.Employee')
	SET @Lang = dbo.adfPropertyValueGetText(@Class, @EmployeeID, '00000004-0000-0000-0000-000000000000')
	
	IF (@Lang IS NULL OR (@Lang != 'ru' AND @Lang != 'en'))
	BEGIN
		SET @Lang = @DefaultLang
	END
	
	RETURN @Lang
end
go

grant execute on [dbo].[fnPjm5GetEmployeeLanguage] to [public]
go