IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncCheckAutoImport')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncCheckAutoImport'
		DROP  Procedure  PjmSyncCheckAutoImport
	END

GO

PRINT 'Creating Procedure PjmSyncCheckAutoImport'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncCheckAutoImport
			 @DeviceID varchar(40),
			 @TimeStampCalendar bigint,
			 @TimeStampTask bigint,
			 @TimeStampCompany timestamp,
			 @TimeStampEmployee timestamp,
			 @DaysBeforeThis int,
			 @DaysBeforeThisTask int,
			 @ContactSelector int,
			 @RequiredImport int OUTPUT

AS
	SET NOCOUNT ON

------------------------------------------------
DECLARE @EmployeeID TIdentifier


	IF (EXISTS(SELECT [ID] FROM dbo.PjmSyncExportAppointmentFunction(@DeviceID, @DaysBeforeThis, @TimeStampCalendar, 0)))
	BEGIN
		SET @RequiredImport = @RequiredImport | 1
	END

	IF (EXISTS(SELECT [ID] FROM dbo.PjmSyncExportTaskFunction(@DeviceID, @DaysBeforeThisTask, @TimeStampTask, 0)))
	BEGIN
		SET @RequiredImport = @RequiredImport | 2
	END

	IF (EXISTS(SELECT [ID] FROM dbo.PjmSyncExportContactFunction(@DeviceID, @TimeStampEmployee, @TimeStampCompany,@ContactSelector,0)))
	BEGIN
		SET @RequiredImport = @RequiredImport | 4
	END
		
	RETURN 0
GO

GRANT EXEC ON PjmSyncCheckAutoImport TO PUBLIC
GO  