IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ProjectSetNextPaymentPeriod]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ProjectSetNextPaymentPeriod'
		DROP PROCEDURE [dbo].[pjm6ProjectSetNextPaymentPeriod]
	END
GO

PRINT 'Creating procedure pjm6ProjectSetNextPaymentPeriod'
GO

/******************************************************************************
**		File: pjm6ProjectSetNextPaymentPeriod.sql
**		Name: pjm6ProjectSetNextPaymentPeriod
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6ProjectSetNextPaymentPeriod]
	@ProjectID TIdentifier,
	@ClassName TName
AS
	SET NOCOUNT ON
	DECLARE
		@PeriodType TCode,
		@DayType TCode,
		@NextPaymentDate TDate
		
	SELECT
		@PeriodType = CASE @ClassName 
			WHEN 'Pjm5.Calculation' THEN [PaymentPeriod].[CalculationPeriodType]
			WHEN 'Pjm5.Statement' THEN [PaymentPeriod].[StatementPeriodType]
			WHEN 'Pjm5.Invoice' THEN [PaymentPeriod].[InvoicePeriodType]
			ELSE 'Unknown'
		END,
		@DayType = CASE @ClassName 
			WHEN 'Pjm5.Calculation' THEN [PaymentPeriod].[CalculationDayType]
			WHEN 'Pjm5.Statement' THEN [PaymentPeriod].[StatementDayType]
			WHEN 'Pjm5.Invoice' THEN [PaymentPeriod].[InvoiceDayType]
			ELSE 'Unknown'
		END,
		@NextPaymentDate = CASE @ClassName 
			WHEN 'Pjm5.Calculation' THEN [PaymentPeriod].[CalculationNextPaymentDate]
			WHEN 'Pjm5.Statement' THEN [PaymentPeriod].[StatementNextPaymentDate]
			WHEN 'Pjm5.Invoice' THEN [PaymentPeriod].[InvoiceNextPaymentDate]
			ELSE NULL
		END
	FROM
		[PaymentPeriod]
	WHERE
		[PaymentPeriod].[ProjectID] = @ProjectID
		
	BEGIN TRANSACTION
	SET @NextPaymentDate = dbo.fnPjm6GetNextPaymentDate(@PeriodType, @DayType, @NextPaymentDate)
	IF @ClassName = 'Pjm5.Calculation'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[CalculationNextPaymentDate] = @NextPaymentDate
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @ClassName = 'Pjm5.Statement'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[StatementNextPaymentDate] = @NextPaymentDate
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @ClassName = 'Pjm5.Invoice'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[InvoiceNextPaymentDate] = @NextPaymentDate
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6ProjectSetNextPaymentPeriod TO PUBLIC
GO