IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trProjectDueDateChange')
	BEGIN
		PRINT 'Dropping Trigger pjm6trProjectDueDateChange'
		DROP  Trigger pjm6trProjectDueDateChange
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trProjectDueDateChange
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trProjectDueDateChange'
GO
CREATE TRIGGER pjm6trProjectDueDateChange ON [ProjectDetail] FOR UPDATE
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON

	UPDATE [Task]
	SET
		[Task].[DueDate] = [inserted].[DueDate],
		[Task].[Duration] = dbo.fnPjm5GetWorkingDays([Project].[Date], [inserted].[DueDate]),
		[Task].[PercentComplete] = [inserted].[PercentComplete],	
		[Task].[Budget] = [inserted].[PlannedBudget],
		[Task].[ManHour] = [inserted].[PlannedManHour]
	FROM 
		[Task]
		INNER JOIN [inserted]
			ON [inserted].[ID] = [Task].[SubProjectID]
		INNER JOIN [Project]
			ON [Project].[ID] = [inserted].[ID]
	WHERE
		[Task].[MsTaskID] IS NULL
	RETURN 