﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ProjectAutoAssign]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ProjectAutoAssign'
		DROP PROCEDURE [dbo].[pjm7ProjectAutoAssign]
	END
GO

PRINT 'Creating procedure pjm7ProjectAutoAssign'
GO

/******************************************************************************
**		File: pjm7ProjectAutoAssign.sql
**		Name: pjm7ProjectAutoAssign
**		Desc: Автопереход проекта при создании в состояние "Открыт"
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAB
**		Date: 16.07.2013
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.01.14	BAO				Добавление возможности смены руководителя
**									при создании проекта, если установлен
**									параметр "Открывать проекты при создании"
*******************************************************************************/
CREATE PROCEDURE [pjm7ProjectAutoAssign]
	@ID TIdentifier
AS
	DECLARE @Value TVariant,
			@UserID int, 
			@AutoAssign bit,
			@rv int

	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT @Value = [Value] FROM [UserParameter] WHERE [Name] = 'ProjectAutoAssign' AND [UserID] = @userID
	SET @AutoAssign = ISNULL(CAST(@Value as bit), 1)	

	IF @AutoAssign = 1
	BEGIN
		DECLARE @CurrentEmployeeID TIdentifier
		SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

			IF dbo.fnPjm5IsProjectManager(@ID, @CurrentEmployeeID) <> 0 OR
				dbo.fnPjm7IsManagerAssistant(@ID, @CurrentEmployeeID) <> 0
			BEGIN
				EXEC @rv = pjm5ProjectChangeState @ID, 2
				IF @rv != 0
				BEGIN
					RETURN @rv
				END
			END
	END

	RETURN 0
GO
