IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportClientGrowth')
	BEGIN
		PRINT 'Dropping Procedure ReportClientGrowth'
		DROP  Procedure  ReportClientGrowth
	END

GO

PRINT 'Creating Procedure ReportClientGrowth'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportClientGrowth
	@SupplierID TIdentifier,
	@CostCenterSelector int,
	@CostCenterID TIdentifier,
	@DateSelector int,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@SupplierName TName,
		@CostCenterName TName,
		@UserID TIdentifier,
		@UserName TName
				
	IF @DateSelector = 0
		BEGIN
			SET @PeriodStart = CAST(YEAR(GETDATE()) AS char(4)) + '0101'
			SET @PeriodEnd = CAST(YEAR(GETDATE())  AS char(4)) + '1231'
		END
	ELSE IF @DateSelector = 1
		BEGIN
			SET @PeriodStart = CAST(YEAR((GETDATE()) - 1) AS char(4)) + '0101'
			SET @PeriodEnd = CAST(YEAR((GETDATE()) - 1) AS char(4)) + '1231'
		END
		--ELSE SET @PeriodEnd = DATEADD(day, 1, @PeriodEnd)
	IF @CostCenterSelector = 1 AND @CostCenterID IS NOT NULL					
		SELECT
			@CostCenterName = [FileAs]
		FROM
			[CostCenter]
		WHERE
			[ID] = @CostCenterID
	SELECT
		@SupplierName = [FileAs]
	FROM
		[Company]
	WHERE
		[ID] = @SupplierID
	
	SET @UserID = dbo.adfGetCurrentUserID()
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID

	SELECT 
		ISNULL(@SupplierName, '()') AS [SupplierName],
		@CostCenterSelector AS [CostCenterSelector],
		ISNULL(@CostCenterName, '( )') AS [CostCenterName],
		YEAR(@PeriodStart) AS [Year],
		@UserName  AS [UserName]

	DECLARE @Date TDate
	SET @Date = @PeriodStart
	DECLARE @dates TABLE([Date] datetime)
	WHILE @Date < @PeriodEnd
	BEGIN
		INSERT INTO @dates([Date]) VALUES (@Date)
		SET @Date = DATEADD(month, 1, @Date)
	END
		
	SELECT 
		[Dates].[Date], 
		COUNT(DISTINCT [Project].[CustomerCompanyID]) AS [CountOfClient]
	FROM
		@dates AS [Dates] 
		INNER JOIN [Project]
			ON  DATEADD(month, 1, [Dates].[Date]) > [Project].[ContractDate] AND 
			YEAR([Dates].[Date]) <= COALESCE(YEAR([Project].[ContractEndDate]), YEAR([Project].[EndDate]), YEAR(@PeriodEnd)) AND 
			MONTH([Dates].[Date]) <= COALESCE(MONTH([Project].[ContractEndDate]), MONTH([Project].[EndDate]), MONTH(@PeriodEnd))
	WHERE
		[Project].[ProjectTypeID] = 1 AND
		(
			@CostCenterSelector = 0 OR
			@CostCenterID IS NULL AND [Project].[CostCenterID] IS NULL OR
			[Project].[CostCenterID] = @CostCenterID
		) AND
		(
			@SupplierID IS NULL OR
			[Project].[SupplierCompanyID] = @SupplierID
		) AND
		[Project].[SupplierCompanyID] != [Project].[CustomerCompanyID] AND
		[Project].[State] NOT IN (1, 5, 6)		
	GROUP BY 
		[Dates].[Date]	
	
	RETURN 0
GO

GRANT EXEC ON ReportClientGrowth TO PUBLIC

GO
