 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportExpense]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportExpense'
		DROP PROCEDURE [dbo].[ReportExpense]
	END
GO

PRINT 'Creating procedure ReportExpense'
GO

/******************************************************************************
**		File: ReportExpense.sql
**		Name: ReportExpense
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportExpense]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@EmployeeID TIdentifier, 
		@UserID TIdentifier, 
		@UserName TName,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@RestrictedView TBool,
		@CreatedBy TIdentifier
		
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @UserID = dbo.adfGetCurrentUserID();
		
	SELECT
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@CreatedBy = [CreatedBy]
	FROM 
		[Expense] 
	WHERE 
		[ID] = @ID
	
	SET @UserID = dbo.adfGetCurrentUserID();
	SELECT @UserName = [Trustee].[DisplayName] FROM [Trustee] WHERE [Trustee].[ID] = @UserID
	
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		CASE WHEN [Expense].[Billable] = 1 THEN ' ' ELSE '  ' END AS [Billable],
		[Expense].[Amount],
		CASE
			WHEN (@ViewAllFinance = 0 AND @EmployeeID != @CurrentEmployeeID AND @CreatedBy!= @UserID AND
				dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 ) THEN -1
			ELSE [Expense].[Price]
		END AS [Price],
		CASE WHEN [Expense].[VATIsIncluded] = 1 THEN ' ' ELSE ' ' END AS [VATIsIncluded],
		CASE
			WHEN (@ViewAllFinance = 0 AND @EmployeeID != @CurrentEmployeeID AND @CreatedBy != @UserID AND
				dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 ) THEN -1
			ELSE [Expense].[Price]*[Expense].[Amount]
		END AS [Total],
		[Expense].[VATRate],
		CASE
			WHEN (@ViewAllFinance = 0 AND @EmployeeID != @CurrentEmployeeID AND @CreatedBy != @UserID AND
				dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 ) THEN -1
			ELSE [Expense].[VAT]
		END AS [VAT],
		[Expense].[FromCurrencyCode],
		[ExpenseCode].[FileAs] AS [ExpenseCodeFileAs],
		[UOM].[FileAs] AS [UOMFileAs],
		[Project].[Number] AS [ProjectNumber],
		[Project].[FileAs] AS [ProjectFileAs],
		[Expense].[EmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[Expense].[Date],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Creator].[FileAs] AS [CreatorFileAs],
		@UserName AS [UserName],
		[Task].[FileAs] AS [TaskFileAs]	
	FROM
		[Expense]
		LEFT OUTER JOIN [ExpenseCode]
			ON [ExpenseCode].[ID] = [Expense].[ExpenseCodeID]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Expense].[EmployeeID]
		INNER JOIN [Employee] AS [Creator]
			ON [Creator].[UserID] = [Expense].[CreatedBy]
		LEFT OUTER JOIN [UOM]
			ON [UOM].[ID] = [Expense].[UOMID]
		LEFT OUTER JOIN [Task]
			ON [Task].[ID] = [Expense].[TaskID]
		
	WHERE
		[Expense].[ID] = @ID
	
	SELECT
		[Note].[Created],
		[Note].[Text],
		[Employee].[FileAs]
	FROM
		[Expense]
		INNER JOIN [Note]
			ON [Expense].[ID] = [Note].[DocumentID] AND
			   [Expense].[Class] = [Note].[DocumentClass]
		INNER JOIN [Employee]
			ON ([Note].[CreatedBy] = [Employee].[UserID])
	WHERE
		[Expense].[ID] = @ID 
	ORDER BY
		[Note].[Created]
	RETURN 0
GO

GRANT EXECUTE ON [ReportExpense] TO PUBLIC
GO