IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportContract')
	BEGIN
		PRINT 'Dropping Procedure ReportContract'
		DROP  Procedure  ReportContract
	END

GO

PRINT 'Creating Procedure ReportContract'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportContract
	@ID int,
	@Language Tname = NULL
AS
	SET NOCOUNT ON
	DECLARE 
		@Class TClass,
		@SupplierID TIdentifier,
		@CustomerID TIdentifier,
		@BankAccountID TIdentifier

	SET @Class = dbo.adfGetClassByName('Adf.Company')	
	SELECT 
		@SupplierID = [Project].[SupplierCompanyID],
		@CustomerID = [Project].[CustomerCompanyID]
	FROM 
		[Project]
	WHERE 
		[Project].[ID] = @ID
	
	SELECT
		@BankAccountID = [BankAccountID]
	FROM
		[Project]
	WHERE
		[ID] = @ID
	
	IF (@BankAccountID IS NULL)
	BEGIN
		SELECT
			@BankAccountID=[Company].[BankAccountID]
		FROM
			[Company], [Project]
		WHERE
			[Project].[ID] = @ID AND
			[Company].[ID] = [Project].[SupplierCompanyID]
	END
	
	SELECT 
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ContractNumber],
		[Project].[ContractSubject],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[CustomerCompanyID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		CAST([Project].[ApplyVAT] AS int) AS [ApplyVAT],
		[SupplierCompany].[LegalName] AS [SupplierLegalName],
		[SupplierCompany].[FileAs] AS [SupplierFileAs],
		[SupplierCompany].[ExecutiveEmployeeID] AS [SupplierExecutiveEmployeeID],
		[SupplierCompany].[AccountantEmployeeID] AS [SupplierAccountantEmployeeID],
		@BankAccountID AS [SupplierBankAccountID],
		[CustomerCompany].[LegalName] AS [CustomerLegalName],
		[CustomerCompany].[FileAs] AS [CustomerFileAs],
		[CustomerCompany].[ExecutiveEmployeeID] AS [CustomerExecutiveEmployeeID],
		[CustomerCompany].[AccountantEmployeeID] AS [CustomerAccountantEmployeeID],
		[CustomerCompany].[BankAccountID] AS [CustomerBankAccountID],
		[SupplierCompany].[LegalCode] AS [SupplierLegalCode],
		[SupplierCompany].[KPP] AS [SupplierKPP],
		[CustomerCompany].[LegalCode] AS [CustomerLegalCode],
		[CustomerCompany].[KPP] AS [CustomerKPP],
		
		[ProjectManagerEmployee].[LastName] + ISNULL(' ' + [ProjectManagerEmployee].[FirstName], '') + ISNULL(' ' + [ProjectManagerEmployee].[MiddleName], '')
			 AS [ProjectManagerEmployeeName],
		[ResponsiblePersonEmployee].[LastName] + ISNULL(' ' + [ResponsiblePersonEmployee].[FirstName], '') + ISNULL(' ' + [ResponsiblePersonEmployee].[MiddleName], '')
			 AS [ResponsiblePersonEmployeeName],
		[SupplierExecutiveEmployee].[LastName] + ISNULL(' ' + [SupplierExecutiveEmployee].[FirstName], '') + ISNULL(' ' + [SupplierExecutiveEmployee].[MiddleName], '')
			AS [SupplierExecutiveEmployeeName],
		[SupplierAccountantEmployee].[LastName] + ISNULL(' ' + [SupplierAccountantEmployee].[FirstName], '') + ISNULL(' ' + [SupplierAccountantEmployee].[MiddleName], '')
			AS [SupplierAccountantEmployeeName],
		[CustomerExecutiveEmployee].[LastName] + ISNULL(' ' + [CustomerExecutiveEmployee].[FirstName], '') + ISNULL(' ' + [CustomerExecutiveEmployee].[MiddleName], '')
			AS [CustomerExecutiveEmployeeName],
		[CustomerAccountantEmployee].[LastName] + ISNULL(' ' + [CustomerAccountantEmployee].[FirstName], '') + ISNULL(' ' + [CustomerAccountantEmployee].[MiddleName], '')
			AS [CustomerAccountantEmployeeName],

		[ProjectManagerEmployee].[FileAs] AS [ProjectManagerEmployeeFileAs],
		[ResponsiblePersonEmployee].[FileAs] AS [ResponsiblePersonEmployeeFileAs],
		[SupplierExecutiveEmployee].[FileAs] AS [SupplierExecutiveEmployeeFileAs],
		[SupplierAccountantEmployee].[FileAs] AS [SupplierAccountantEmployeeFileAs],
		[CustomerExecutiveEmployee].[FileAs] AS [CustomerExecutiveEmployeeFileAs],
		[CustomerAccountantEmployee].[FileAs] AS [CustomerAccountantEmployeeFileAs],
		
		[ProjectManagerEmployee].[PositionID] AS [ProjectManagerEmployeePositionID],
		[ResponsiblePersonEmployee].[PositionID] AS [ResponsiblePersonEmployeePositionID],
		[SupplierExecutiveEmployee].[PositionID] AS [SupplierExecutiveEmployeePositionID],
		[SupplierAccountantEmployee].[PositionID] AS [SupplierAccountantEmployeePositionID],
		[CustomerExecutiveEmployee].[PositionID] AS [CustomerExecutiveEmployeePositionID],
		[CustomerAccountantEmployee].[PositionID] AS [CustomerAccountantEmployeePositionID]		
	FROM 
		[Project]
		INNER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]
		INNER JOIN [Company] AS [CustomerCompany]
			ON [Project].[CustomerCompanyID] = [CustomerCompany].[ID]
		LEFT OUTER JOIN [Employee] AS [ProjectManagerEmployee]
			ON [ProjectManagerEmployee].[ID] = [Project].[ProjectManagerEmployeeID]
		LEFT OUTER JOIN [Employee] AS [ResponsiblePersonEmployee]
			ON [ResponsiblePersonEmployee].[ID] = [Project].[ResponsiblePersonEmployeeID]
		LEFT OUTER JOIN [Employee] AS [SupplierExecutiveEmployee]
			ON [SupplierExecutiveEmployee].[ID] = [SupplierCompany].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [SupplierAccountantEmployee]
			ON [SupplierAccountantEmployee].[ID] = [SupplierCompany].[AccountantEmployeeID]
		LEFT OUTER JOIN [Employee] AS [CustomerExecutiveEmployee]
			ON [CustomerExecutiveEmployee].[ID] = [CustomerCompany].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [CustomerAccountantEmployee]
			ON [CustomerAccountantEmployee].[ID] = [CustomerCompany].[AccountantEmployeeID]		
	WHERE 
		[Project].[ID] = @ID
		
	
	SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail],
		dbo.fnPjm5AddressAsString([Address].[Street], [Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AsString]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @SupplierID AND 
		[Address].[BusinessCardClass] = @Class  
		
	SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail],
		dbo.fnPjm5AddressAsString([Address].[Street], [Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AsString]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @CustomerID AND 
		[Address].[BusinessCardClass] = @Class
	

	DECLARE @author TName
	SELECT @author = [FileAs] FROM [Employee] WHERE [ID] = dbo.adfGetCurrentEmployeeID()
	SELECT
		[Project].[FileAs] AS [Title],
		[Project].[ContractSubject] AS [Subject],
		@author AS [Author],
		[Employee].[FileAs] AS [Manager],
		[Company].[LegalName] AS [Company],
		dbo.fnPjm5GetCategoryList([Project].[ID], [Project].[Class]) AS [Category],
		[Project].[ContractNumber] + ';' + [Project].[Number] AS [Keywords]
     FROM
		[Project]
		INNER JOIN [Company]
			ON [Project].[SupplierCompanyID] = [Company].[ID]
		INNER JOIN [Employee]
			ON [Project].[ProjectManagerEmployeeID] = [Employee].[ID]
     WHERE
		[Project].[ID] = @ID
		
	SELECT
		[Service].[ID],
		[Service].[Code] AS [ServiceCode],
		[ServiceAssignment].[FileAs] AS [ServiceAssignmentFileAs],
		[ServiceAssignment].[Price],
		[Project].[CurrencyCode],
		[ServiceAssignment].[VATIsIncluded],
		[UOM].[FileAs] AS [UOMFileAs],
		[ServiceType].[Code] AS [ServiceTypeCode],
		[ServiceType].[FileAs] AS [ServiceTypeFileAs]
	FROM
		[Project]
		LEFT OUTER JOIN [ServiceAssignment]
		ON [ServiceAssignment].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [Service]
		ON [Service].[ID] = [ServiceAssignment].[ServiceID]
		LEFT OUTER JOIN [UOM] 
		ON [UOM].[ID] = [Service].[UOMID]
		LEFT OUTER JOIN [ServiceType]
		ON [ServiceType].[ID] = [Service].[ServiceTypeID]
	WHERE
		[Project].[ID] = @ID
	
	--////////////////////////////////SupplierEmail/////////////////////////////		
	SELECT
		[Email].[EmailTypeID],
		[Email].[Email]
	FROM
		[Email]
	WHERE
		[Email].[BusinessCardID]=@SupplierID AND
		[Email].[BusinessCardClass] = @Class AND
		[Email].[EmailTypeID] IN (1,2,3)
	
--////////////////////////////////CustomerEmail/////////////////////////////		
	SELECT
		[Email].[EmailTypeID],
		[Email].[Email]
	FROM
		[Email]
	WHERE
		[Email].[BusinessCardID] = @CustomerID AND
		[Email].[BusinessCardClass] = @Class AND
		[Email].[EmailTypeID] IN (1,2,3)

--////////////////////////////////SupplierPhone//////////////////////////////		
	SELECT
		[T].[PhoneTypeID],
		[T].[Phone]
	FROM
	(
	SELECT
		0 as [Chapter],
		[Phone].[PhoneTypeID],
		[Phone].[Phone]
	FROM
		[Phone]	
	WHERE
		[Phone].[BusinessCardID] = @SupplierID AND 
		[Phone].[BusinessCardClass] = @Class AND
		[Phone].[PhoneTypeID] IN (7, 11)
	UNION ALL
	SELECT
		1 as [Chapter],
		[Phone].[PhoneTypeID],
		[Phone].[Phone]
	FROM
		[Phone]		
	WHERE
		[Phone].[BusinessCardID] = @SupplierID AND 
		[Phone].[BusinessCardClass] = @Class AND
		[Phone].[PhoneTypeID] NOT IN (7, 11)) as [T]
	ORDER BY
		[Chapter], [PhoneTypeID]
	
--////////////////////////////////CustomerPhone//////////////////////////////	
	SELECT
			[Phone].[PhoneTypeID],
			[Phone].[Phone]
		FROM
			[Phone]	
		WHERE
			[Phone].[BusinessCardID] = @CustomerID AND 
			[Phone].[BusinessCardClass] = @Class
		
	RETURN 0
GO

GRANT EXEC ON ReportContract TO PUBLIC
GO
