IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ServiceAssignmentBrowseSelectorDialogCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ServiceAssignmentBrowseSelectorDialogCalculation'
		DROP PROCEDURE [dbo].[ServiceAssignmentBrowseSelectorDialogCalculation]
	END
GO

PRINT 'Creating procedure ServiceAssignmentBrowseSelectorDialog'
GO

/******************************************************************************
**		File: ServiceAssignmentBrowseSelectorDialogCalculation
**		Name: ServiceAssignmentBrowseSelectorDialogCalculation
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ServiceAssignmentBrowseSelectorDialogCalculation]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON

	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[ServiceAssignment].[ID],
		[ServiceAssignment].[State],
		[ServiceAssignment].[ProjectID],
		[Service].[Code],
		[ServiceAssignment].[FileAs],
		[PaymentTerm].[FileAs] AS [PaymentTerm]
	FROM
		[ServiceAssignment]
		INNER JOIN fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
		INNER JOIN [Service] 
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
		LEFT OUTER JOIN [PaymentTerm]
			ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
	WHERE
		(
			@ProjectID IN (0, -1, -2, -3, -4) OR
			[ServiceAssignment].[ProjectID] = @ProjectID
		) AND
		( [ServiceAssignment].[State] IN (1) )
		
	RETURN 0
GO

GRANT EXECUTE ON [ServiceAssignmentBrowseSelectorDialogCalculation] TO PUBLIC
GO
 