IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestSelectorDialog'
GO

/******************************************************************************
**		File: pjm5ServiceRequestSelectorDialog.sql
**		Name: pjm5ServiceRequestSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestSelectorDialog]
	@ProjectID		INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@Employee		TName,
	@DocumentClass	TClass
AS
	SET NOCOUNT ON
	DECLARE
		@invoiceClass TClass,
		@statementClass TClass
	SET @invoiceClass =dbo.adfGetClassByName('Pjm5.Invoice')
	SET @statementClass =dbo.adfGetClassByName('Pjm5.Statement')

	DECLARE
		@ApplyVAT TBool,
		@VATRate TAmount,
		@value TVariant
	SET @VATRate = 0
	SELECT @ApplyVAT = [Project].[ApplyVAT] FROM [Project] WHERE [Project].[ID] = @ProjectID
	IF @ApplyVAT = 1
	BEGIN
		EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
	END

	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[Date],
		[ServiceRequest].[VATIsIncluded],
		CASE 
			WHEN [ServiceRequest].[VATIsIncluded] = 1
				THEN SUM([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]) / (1.0 + @VATRate)
			ELSE SUM([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]) 
		END AS [SumWithoutVAT],
		CASE 
			WHEN [ServiceRequest].[VATIsIncluded] = 1
				THEN SUM([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price])
			ELSE SUM([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]) * (1.0 + @VATRate)
		END AS [SumWithVAT],
		[Project].[CurrencyCode],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[Employee].[FileAs] AS [EmployeeName]
	FROM
		[ServiceRequest]
		INNER JOIN [ServiceRequestLine]
			ON [ServiceRequestLine].[ServiceRequestID] = [ServiceRequest].[ID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[Project].[ID] = @ProjectID AND
		[ServiceRequest].[Date] BETWEEN @PeriodStart AND @PeriodEnd AND 
		[ServiceRequest].[Billable] = 1 AND
		[ServiceRequest].[State] IN (4, 5) AND
		(@Employee IS NULL OR [Employee].[FileAs] LIKE @Employee) AND
		NOT EXISTS(
			SELECT * 
			FROM 
				[CalculationLine] 
				INNER JOIN [Calculation]
					ON [Calculation].[ID] = [CalculationLine].[CalculationID]
			WHERE 
				[Calculation].[State] != 4 AND
				[CalculationLine].[DocumentClass] = [ServiceRequest].[Class] AND [CalculationLine].[DocumentID] = [ServiceRequest].[ID]
		) AND
		(
			(@DocumentClass = @invoiceClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[InvoiceLine] 
						INNER JOIN [Invoice]
							ON [Invoice].[ID] = [InvoiceLine].[InvoiceID]
					WHERE 
						[Invoice].[State] != 3 AND
						[InvoiceLine].[DocumentClass] = [ServiceRequest].[Class] AND [InvoiceLine].[DocumentID] = [ServiceRequest].[ID]))
			OR
			(@DocumentClass = @statementClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[StatementLine] 
						INNER JOIN [Statement]
							ON [Statement].[ID] = [StatementLine].[StatementID]
					WHERE 
						[Statement].[State] != 4 AND
						[StatementLine].[DocumentClass] = [ServiceRequest].[Class] AND [StatementLine].[DocumentID] = [ServiceRequest].[ID])
			)
		)
	GROUP BY
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[Date],
		[ServiceRequest].[VATIsIncluded],
		[Project].[CurrencyCode],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[Employee].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestSelectorDialog] TO PUBLIC
GO

