 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceTypeBrowse.sql
**		Name: pjm5ServiceTypeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceTypeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[ServiceType].[Class],
		[ServiceType].[ID],
		[ServiceType].[State],
		[ServiceType].[Flag],
		[ServiceType].[Code],
		[ServiceType].[FileAs],
		[ServiceType].[RatesDepended],
		[ServiceType].[Comments],
		[ServiceType].[Created],
		[ServiceType].[CreatedBy],
		[ServiceType].[Modified],
		[ServiceType].[ModifiedBy],
		[ServiceType].[Timestamp]
	FROM
		[ServiceType]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [ServiceType].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceTypeBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeGet'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeGet]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeGet'
GO

/******************************************************************************
**		File: pjm5ServiceTypeGet.sql
**		Name: pjm5ServiceTypeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceTypeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ServiceType].[Class],
		[ServiceType].[ID],
		[ServiceType].[State],
		[ServiceType].[Flag],
		[ServiceType].[Code],
		[ServiceType].[FileAs],
		[ServiceType].[RatesDepended],
		[ServiceType].[Comments],
		[ServiceType].[Created],
		[ServiceType].[CreatedBy],
		[ServiceType].[Modified],
		[ServiceType].[ModifiedBy],
		[ServiceType].[Timestamp]
	FROM
		[ServiceType]
	WHERE
		[ServiceType].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceTypeGet] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeCreate'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeCreate]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeCreate'
GO

/******************************************************************************
**		File: pjm5ServiceTypeCreate.sql
**		Name: pjm5ServiceTypeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceTypeCreate]
	@Code TCode,
	@FileAs TName,
	@RatesDepended TBool,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('1de40443-d599-4d69-94f6-dd248d8f7171')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ServiceType]
		([Flag], [State], [Code], [FileAs], [RatesDepended], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @RatesDepended, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5ServiceTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceTypeCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeUpdate'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeUpdate]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceTypeUpdate.sql
**		Name: pjm5ServiceTypeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceTypeUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@RatesDepended TBool,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ServiceType]
	SET
		[ServiceType].[Code] = @Code,
		[ServiceType].[FileAs] = @FileAs,
		[ServiceType].[RatesDepended] = @RatesDepended,
		[ServiceType].[Comments] = @Comments,
		[ServiceType].[Modified] = DEFAULT,
		[ServiceType].[ModifiedBy] = DEFAULT
	WHERE
		[ServiceType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ServiceTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceTypeUpdate TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeDelete'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeDelete]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeDelete'
GO

/******************************************************************************
**		File: pjm5ServiceTypeDelete.sql
**		Name: pjm5ServiceTypeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceTypeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ServiceType] WHERE [ServiceType].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceTypeDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceTypeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceTypeChangeState'
		DROP PROCEDURE [dbo].[pjm5ServiceTypeChangeState]
	END
GO

PRINT 'Creating procedure pjm5ServiceTypeChangeState'
GO

/******************************************************************************
**		File: pjm5ServiceTypeChangeState.sql
**		Name: pjm5ServiceTypeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/10/2006 18:13:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceTypeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ServiceType].[Class],
		@FromState = [ServiceType].[State]
	FROM
		[ServiceType]
	WHERE
		[ServiceType].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[ServiceType]
	SET
		[ServiceType].[State] = @ToState,
		[ServiceType].[Modified] = DEFAULT,
		[ServiceType].[ModifiedBy] = DEFAULT
	WHERE
		[ServiceType].[ID] = @ID
	AND
		[ServiceType].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceTypeChangeState TO PUBLIC
GO

