IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5StickerPrint')
	BEGIN
		PRINT 'Dropping Procedure pjm5StickerPrint'
		DROP  Procedure  pjm5StickerPrint
	END

GO

PRINT 'Creating Procedure pjm5StickerPrint'
GO

--------------------------------------------------------------------------------------
CREATE Procedure pjm5StickerPrint
	@ID TIdentifier
	
AS
	SET NOCOUNT ON

------------------------------------------------
	DECLARE
		@UserID TIdentifier,
		@UserName TName
	SET @UserID = dbo.adfGetCurrentUserID()	
	
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID

	SELECT
		[Recipient].[ID] AS [RecipientID],
		[Recipient].[FileAs] AS [RecipientFileAs],
		[Createdby].[ID] AS [CreatedByID],
		[CreatedBy].[FileAs] AS [CreatedFileAs],
		[Sticker].[FileAs] AS [StickerFileAs],
		[Sticker].[Comments],
		[Sticker].[Modified],
		@UserName AS [UserName]
	FROM 
		[Sticker]
			INNER JOIN [Employee] AS [Recipient]
				ON [Sticker].[RecipientUserID] = [Recipient].[UserID]
			INNER JOIN [Employee] AS [CreatedBy]
				ON [Sticker].[CreatedBy] = [CreatedBy].[UserID]
	WHERE [Sticker].[ID] = @ID

	RETURN 0
GO

GRANT EXEC ON pjm5StickerPrint TO PUBLIC
GO    