
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskBudgetUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskBudgetUpdate'
		DROP PROCEDURE [dbo].[pjm6TaskBudgetUpdate]
	END
GO

PRINT 'Creating procedure pjm6TaskBudgetUpdate'
GO

/******************************************************************************
**		File: pjm6TaskBudgetUpdate.sql
**		Name: pjm6TaskBudgetUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6TaskBudgetUpdate
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @Budget TMoney
	SELECT
		@Budget = SUM([TaskAssignment].[Work] * [Assignment].[StandardRate] / 60.0)
	FROM
		[TaskAssignment]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
	WHERE
		[TaskAssignment].[TaskID] = @ID
		
	UPDATE
		[Task]
	SET
		[Budget] = ISNULL(@Budget, 0)
	WHERE
		[ID] = @ID AND [State] IN (2, 5, 6, 8)
	IF @@ERROR != 0
		RETURN 1
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6TaskBudgetUpdate TO PUBLIC
GO
 