IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5TaskBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5TaskBrowseSelectorDialog'
GO

/******************************************************************************
**		File: TaskBrowseSelectorDialog.sql
**		Name: pjm5TaskBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskBrowseSelectorDialog]
	@EmployeeID	TIdentifier,
	@ProjectID	TIdentifier,
	@State TState,
	@ExcludeExpiredTermsTasks bit = 0
AS
	SET NOCOUNT ON
	
	IF @EmployeeID = -1 
		SELECT @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT DISTINCT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[FileAs],
		[Project].[Number] AS [ProjectCode],
		[Task].[StartDate],
		[Task].[DueDate]
	FROM
		[Task]
		INNER JOIN [Project]
			ON [Project].[ID] = [Task].[ProjectID]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
			AND [TaskAssignment].[State] = 1
			--AND
			--(
				--@ExcludeExpiredTermsTasks = 0 OR [Task]
				--OR(
				--[TaskAssignment].[MsAvailable] = 1
				--AND(
				--	[TaskAssignment].[RemainingWork] != 0
				--	OR [TaskAssignment].[RemainingOvertimeWork] !=0
				--	OR [TaskAssignment].[RemainingOvertimeWork] IS NULL
				--	)
				--)
			--)
		LEFT OUTER JOIN [vwAssignment] AS [Assignment]
			ON [Assignment].[ID] = [TaskAssignment].[AssignmentID]
	WHERE
		(
			[Assignment].[EmployeeID] = IsNull(@EmployeeID, [Assignment].[EmployeeID])
		) AND
		(
			@State IS NULL AND [Task].[State] NOT IN (7, 8) OR
			[Task].[State] = @State
		)
		AND
		(
			@ProjectID IS NULL OR [Project].[ID] = @ProjectID
		) AND [Task].[SubprojectID] IS NULL
		AND
		(
			@ExcludeExpiredTermsTasks = 0 OR [Task].[PercentComplete] < 1
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskBrowseSelectorDialog] TO PUBLIC
GO
   
   

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskAssignmentBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskAssignmentBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5TaskAssignmentBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5TaskAssignmentBrowseSelectorDialog'
GO

/******************************************************************************
**		File: TaskBrowseSelectorDialog.sql
**		Name: pjm5TaskAssignmentBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskAssignmentBrowseSelectorDialog]
	@ProjectID	TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Assignment].[ID],
		[Assignment].[Class],
		[Assignment].[State],
		[Assignment].[FileAs] as [Name],
		ISNULL([Company].[LegalName], [Company].[FileAs]) as [Organization],
		[Qualification].[FileAs] as [Qualification]
	FROM
		[vwAssignment] AS [Assignment]
		LEFT OUTER JOIN [Qualification]
			ON [Assignment].[QualificationID] = [Qualification].[ID]
		LEFT OUTER JOIN [Employee]
			ON [Assignment].[EmployeeID] = [Employee].[ID]
		LEFT OUTER JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
	WHERE
		[Assignment].[ProjectID] = @ProjectID 
		AND
		[Assignment].[State] IN (1,3)  --     
		AND
		([Assignment].[ID] IS NOT NULL) 
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskAssignmentBrowseSelectorDialog] TO PUBLIC
GO
   