IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestAssignmentAppendNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestAssignmentAppendNotification'
	DROP PROCEDURE [dbo].[pjm6TaskRequestAssignmentAppendNotification]
END
GO

PRINT 'Creating procedure pjm6TaskRequestAssignmentAppendNotification'
GO

/******************************************************************************
**		File: pjm6TaskRequestAssignmentAppendNotification.sql
**		Name: pjm6TaskRequestAssignmentAppendNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestAssignmentAppendNotification]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0
	
	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestAppointed',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		CASE @Language 
			WHEN 'en' THEN 'You have been assigned to Task Request "' + @FileAs + '".' 
			ELSE '    "' + @FileAs + '".'
		END)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestAssignmentAppendNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestAssignmentDeleteNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestAssignmentDeleteNotification'
	DROP PROCEDURE [dbo].[pjm6TaskRequestAssignmentDeleteNotification]
END
GO

PRINT 'Creating procedure pjm6TaskRequestAssignmentDeleteNotification'
GO

/******************************************************************************
**		File: pjm6TaskRequestAssignmentDeleteNotification.sql
**		Name: pjm6TaskRequestAssignmentDeleteNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestAssignmentDeleteNotification]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestExcluded',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		CASE @Language 
			WHEN 'en' THEN 'You have been excluded from Task Request "' + @FileAs + '".' 
			ELSE '      "' + @FileAs + '".'
		END)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestAssignmentDeleteNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestAssignmentAcceptNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestAssignmentAcceptNotification'
	DROP PROCEDURE [dbo].[pjm6TaskRequestAssignmentAcceptNotification]
END
GO

PRINT 'Creating procedure pjm6TaskRequestAssignmentAcceptNotification'
GO

/******************************************************************************
**		File: pjm6TaskRequestAssignmentAcceptNotification.sql
**		Name: pjm6TaskRequestAssignmentAcceptNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		30.10.09	Anton Paramonov    , 
**                                   
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestAssignmentAcceptNotification]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier,
	@FileAs TName = NULL,
	@Comments TNotes = NULL
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@EmployeeFileAs TName
		
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	IF @FileAs IS NULL
		SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
		
	IF @Comments IS NULL
	BEGIN
		SELECT @EmployeeFileAs = [FileAs] FROM [Employee] WHERE [UserID] = @FromID
		SET @Comments = CASE @Language 
			WHEN 'en' THEN @EmployeeFileAs + ' accepted appointment to Task Request "' + @FileAs + '".' 
			ELSE @EmployeeFileAs + '   "' + @FileAs + '".'
			END
	END
	
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestAccepted',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		@Comments)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestAssignmentAcceptNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestAssignmentDeclineNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestAssignmentDeclineNotification'
	DROP PROCEDURE [dbo].[pjm6TaskRequestAssignmentDeclineNotification]
END
GO

PRINT 'Creating procedure pjm6TaskRequestAssignmentDeclineNotification'
GO

/******************************************************************************
**		File: pjm6TaskRequestAssignmentDeclineNotification.sql
**		Name: pjm6TaskRequestAssignmentDeclineNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		30.10.09	Anton Paramonov    , 
**                                    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestAssignmentDeclineNotification]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier,
	@FileAs TName = NULL,
	@Comments TNotes = NULL
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@EmployeeFileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	IF @FileAs IS NULL
		SELECT @FileAs = [FileAs] 
			FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	IF @Comments IS NULL
	BEGIN
		SELECT @EmployeeFileAs = [FileAs] FROM [Employee] WHERE [UserID] = @FromID
		SET @Comments = CASE @Language 
			WHEN 'en' THEN @EmployeeFileAs + ' declined appointment to Task Request "' + @FileAs + '".'
			ELSE @EmployeeFileAs + '   "' + @FileAs + '".'
			END
	END
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestDeclined',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		@Comments)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestAssignmentDeclineNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestSupervisorOnAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestSupervisorOnAssignment'
	DROP PROCEDURE [dbo].[pjm6TaskRequestSupervisorOnAssignment]
END
GO

PRINT 'Creating procedure pjm6TaskRequestSupervisorOnAssignment'
GO

/******************************************************************************
**		File: pjm6TaskRequestSupervisorOnAssignment.sql
**		Name: pjm6TaskRequestSupervisorOnAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestSupervisorOnAssignment]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestSupervisorAssigned',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		CASE @Language 
			WHEN 'en' THEN 'You have been assigned as Task Request "' + @FileAs + '" Supervisor.'
			ELSE '    "' + @FileAs + '".'
		END)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestSupervisorOnAssignment] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestSupervisorOffAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestSupervisorOffAssignment'
	DROP PROCEDURE [dbo].[pjm6TaskRequestSupervisorOffAssignment]
END
GO

PRINT 'Creating procedure pjm6TaskRequestSupervisorOffAssignment'
GO

/******************************************************************************
**		File: pjm6TaskRequestSupervisorOffAssignment.sql
**		Name: pjm6TaskRequestSupervisorOffAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestSupervisorOffAssignment]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestSupervisorDismissed',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		CASE @Language 
			WHEN 'en' THEN 'Your Task Request "' + @FileAs + '" Supervisor assignment has been canceled.'
			ELSE '     "' + @FileAs + '".'
		END)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestSupervisorOffAssignment] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestPercentChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestPercentChanged'
	DROP PROCEDURE [dbo].[pjm6TaskRequestPercentChanged]
END
GO

PRINT 'Creating procedure pjm6TaskRequestPercentChanged'
GO

/******************************************************************************
**		File: pjm6TaskRequestPercentChanged.sql
**		Name: pjm6TaskRequestPercentChanged
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestPercentChanged]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier,
	@PrevPercent TPercent,
	@NewPercent TPercent
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@Message TName,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	IF @Language = 'en'
		SET @Message = 'Task Request "' + @FileAs + '" completion rate changed from ' + CAST(CAST(@PrevPercent * 100 AS int) AS varchar(265)) + '% to ' + CAST(CAST(@NewPercent * 100 AS int) AS varchar(265)) + '%'
	ELSE 
		SET @Message = '   "' + @FileAs + '"   ' + CAST(CAST(@PrevPercent * 100 AS int) AS varchar(265)) + '%  ' + CAST(CAST(@NewPercent * 100 AS int) AS varchar(265)) + '%.'
			 
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestCompletionRate',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		@Message)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestPercentChanged] TO [public]
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestStartTimeChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestStartTimeChanged'
	DROP PROCEDURE [dbo].[pjm6TaskRequestStartTimeChanged]
END
GO

PRINT 'Creating procedure pjm6TaskRequestStartTimeChanged'
GO

/******************************************************************************
**		File: pjm6TaskRequestStartTimeChanged.sql
**		Name: pjm6TaskRequestStartTimeChanged
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: PAM
**		Date: 13.11.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestStartTimeChanged]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier,
	@PrevStartTime DateTime,
	@NewStartTime DateTime
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@Message TName,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	IF @Language = 'en'
		SET @Message = 'Task Request "' + @FileAs + '" start time changed from ' + CONVERT(nvarchar(16), @PrevStartTime, 20) + ' to ' + CONVERT(nvarchar(16), @NewStartTime, 20)
	ELSE 
		SET @Message = '    "' + @FileAs + '"   ' + CONVERT(nvarchar(16), @PrevStartTime, 20) + '  ' + CONVERT(nvarchar(16), @NewStartTime, 20)
			 
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestStartTime',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		@Message)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestStartTimeChanged] TO [public]
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestDueTimeChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskRequestDueTimeChanged'
	DROP PROCEDURE [dbo].[pjm6TaskRequestDueTimeChanged]
END
GO

PRINT 'Creating procedure pjm6TaskRequestDueTimeChanged'
GO

/******************************************************************************
**		File: pjm6TaskRequestDueTimeChanged.sql
**		Name: pjm6TaskRequestDueTimeChanged
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: PAM
**		Date: 13.11.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestDueTimeChanged]
	@TaskRequestID TIdentifier,
	@UserID TIdentifier,
	@PrevDueTime DateTime,
	@NewDueTime DateTime
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@Message TName,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @TaskRequestID
	IF @Language = 'en'
		SET @Message = 'Task Request "' + @FileAs + '" due time changed from ' + CONVERT(nvarchar(16), @PrevDueTime, 20) + ' to ' + CONVERT(nvarchar(16), @NewDueTime, 20)
	ELSE 
		SET @Message = '   "' + @FileAs + '"   ' + CONVERT(nvarchar(16), @PrevDueTime, 20) + '  ' + CONVERT(nvarchar(16), @NewDueTime, 20)
			 
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'TaskRequestDueTime',
		@FromID,
		@UserID,
		@Class,
		@TaskRequestID,
		0,
		NULL,
		@Message)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6TaskRequestDueTimeChanged] TO [public]
GO