IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentTimeEntryBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentTimeEntryBrowse'
		DROP PROCEDURE [dbo].[pjm6DocumentTimeEntryBrowse]
	END
GO

PRINT 'Creating procedure pjm6DocumentTimeEntryBrowse'
GO

/******************************************************************************
**		File: DocumentTimeEntryBrowse.sql
**		Name: pjm6DocumentTimeEntryBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 28/05/09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.05.09	SPV				 TimeEntryBrowse   
**									 
**		01.04.13	SOV				. -      
**		11.09.13	SOV				    ;
**									-     . -
**		17.10.13	SOV				   - fnpjm7BillableHourGet
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentTimeEntryBrowse]
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DocumentID TIdentifier,
	@DocumentClass TClass,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@HasFinansDataAccess INT,
		@AllowCreateProjectEntry INT,
		@IsProjectMember INT,
		@ProjectID INT,
		@ViewAllProjects TBool,
		@Assistant TBool,
		@TaskRequestClass TClass,
		@value	TVariant,
		@BillableHoursStyle int

	EXEC adfParameterGet @Name='BillableHoursStyle', @Group='Pjm7', @Value = @Value OUTPUT
	SET	@BillableHoursStyle = CONVERT(int, @value)

	SET @TaskRequestClass = dbo.adfGetClassByName('Pjm5.TaskRequest')		
	SET @ViewAllFinance = dbo.adfHasAccessRightByName('ViewAllFinance')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
	
	SELECT TOP 1 @ProjectID = [TimeEntry].[ProjectID]
	FROM
		[vwTimeEntry] as [TimeEntry]
	WHERE
		(			
			[TimeEntry].[DocumentID] = @DocumentID AND [TimeEntry].[DocumentClass] = @DocumentClass
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) 
	
	SET @HasFinansDataAccess = dbo.fnPjm5HasFinansDataAccess(@ProjectID, @CurrentEmployeeID, NULL, NULL)
	
	SET @AllowCreateProjectEntry = dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @CurrentEmployeeID)
		
	SET @ViewAllProjects = dbo.adfHasAccessRightByName('ViewAllProjects')
	SET @Assistant = dbo.adfHasAccessRightByName('Assistant')
	
	IF @AllowCreateProjectEntry = 0 AND @ViewAllProjects = 1 AND @Assistant = 1
	   SET @AllowCreateProjectEntry = 1

	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		dbo.fnpjm7BillableHourGet([TimeEntry].[ProjectID], [TimeEntry].[BillableDuration], @BillableHoursStyle,
			CASE [TimeEntry].[EmployeeID]
				WHEN @CurrentEmployeeID THEN 1
				ELSE 0
			END
		) AS BillableDuration,
		[TimeEntry].[Overtime],
		CASE 
			WHEN @HasFinansDataAccess != 1 THEN -1
			ELSE [TimeEntry].[Rate]
		END AS [Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE 
			WHEN @HasFinansDataAccess != 1 THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	WHERE
		( 
			@ViewAllFinance = 1 OR 
			@AllowCreateProjectEntry = 1 OR
			@DocumentClass = @TaskRequestClass
		) AND
		(
			[TimeEntry].[DocumentClass] = @DocumentClass AND [TimeEntry].[DocumentID] = @DocumentID
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [TimeEntry].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [TimeEntry].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [TimeEntry].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [TimeEntry].[State] = 6) OR			--   
			(@StateSelector = 5 AND [TimeEntry].[State] = 4)			-- 
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentTimeEntryBrowse] TO PUBLIC
GO

/*
**made by Nikita
*/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentTimeEntryBrowseExtended]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentTimeEntryBrowseExtended'
		DROP PROCEDURE [dbo].[pjm6DocumentTimeEntryBrowseExtended]
	END
GO

PRINT 'Creating procedure pjm6DocumentTimeEntryBrowseExtended'
GO

/******************************************************************************
**		File: DocumentTimeEntryBrowse.sql
**		Name: pjm6DocumentTimeEntryBrowseExtended
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: nikita.alexandrov
**		Date: 09/07/09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.05.09	SPV				 TimeEntryBrowseExtended   
**									 
**		01.04.13	SOV				. -      
**		11.09.13	SOV				    ;
**									-     . -
**		17.10.13	SOV				   - fnpjm7BillableHourGet
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentTimeEntryBrowseExtended]
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DocumentID TIdentifier,
	@DocumentClass TClass,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	SET DATEFIRST 1
	DECLARE
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@HasFinansDataAccess INT,
		@AllowCreateProjectEntry INT,
		@IsProjectMember INT,
		@ProjectID INT,
		@ViewAllProjects TBool,
		@Assistant TBool,
		@TaskRequestClass TClass,
		@value	TVariant,
		@BillableHoursStyle int

	EXEC adfParameterGet @Name='BillableHoursStyle', @Group='Pjm7', @Value = @Value OUTPUT
	SET	@BillableHoursStyle = CONVERT(int, @value)

	SET @TaskRequestClass = dbo.adfGetClassByName('Pjm5.TaskRequest')		
	SET @ViewAllFinance = dbo.adfHasAccessRightByName('ViewAllFinance')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
	
	SELECT TOP 1 @ProjectID = [TimeEntry].[ProjectID]
	FROM
		[vwTimeEntry] as [TimeEntry]
	WHERE
		(			
			[TimeEntry].[DocumentID] = @DocumentID AND [TimeEntry].[DocumentClass] = @DocumentClass
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) 
	
	SET @HasFinansDataAccess = dbo.fnPjm5HasFinansDataAccess(@ProjectID, @CurrentEmployeeID, NULL, NULL)
	SET @AllowCreateProjectEntry = dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @CurrentEmployeeID)
		
	SET @ViewAllProjects = dbo.adfHasAccessRightByName('ViewAllProjects')
	SET @Assistant = dbo.adfHasAccessRightByName('Assistant')

	IF @AllowCreateProjectEntry = 0 AND @ViewAllProjects = 1 AND @Assistant = 1
	   SET @AllowCreateProjectEntry = 1
	   
	EXEC pjm6TimeEntryBrowseParameters
			@DateSelector, 
			@PeriodStart	OUTPUT,
			@PeriodEnd		OUTPUT
	
	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		dbo.fnpjm7BillableHourGet([TimeEntry].[ProjectID], [TimeEntry].[BillableDuration], @BillableHoursStyle,
			CASE [TimeEntry].[EmployeeID]
				WHEN @CurrentEmployeeID THEN 1
				ELSE 0
			END
		) AS BillableDuration,
		[TimeEntry].[Overtime],
		CASE 
			WHEN @HasFinansDataAccess != 1 THEN -1
			ELSE [TimeEntry].[Rate]
		END AS [Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE 
			WHEN @HasFinansDataAccess != 1 THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	WHERE
		( 
			@ViewAllFinance = 1 OR 
			@AllowCreateProjectEntry = 1 OR
			@DocumentClass = @TaskRequestClass
		) AND
		(
			[TimeEntry].[DocumentClass] = @DocumentClass AND [TimeEntry].[DocumentID] = @DocumentID
		) AND
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) AND 
		(	
			@DateSelector = 0
				OR 
				(
					[TimeEntry].[StartTime] >= @PeriodStart
					AND
					[TimeEntry].[StartTime] < @PeriodEnd
					--[MeetingRequest].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd
				)
		)
		 AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [TimeEntry].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [TimeEntry].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [TimeEntry].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [TimeEntry].[State] = 6) OR			--   
			(@StateSelector = 5 AND [TimeEntry].[State] = 4)			-- 
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentTimeEntryBrowseExtended] TO PUBLIC
GO