IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryApproveBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryApproveBrowse'
		DROP PROCEDURE [dbo].[pjm5TimeEntryApproveBrowse]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryApproveBrowse'
GO

/******************************************************************************
**		File: pjm5TimeEntryApproveBrowse.sql
**		Name: pjm5TimeEntryApproveBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.11.12	SAP				  " "
**    	04.03.13	SAP				    
**									 " "      
**		26.04.13	SOV				  "" ("Rate")     -
**		05.09.13	SOV				    
**		24.07.14	BAO				     ,   
**									  
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm5TimeEntryApproveBrowse]
	@DateSelector		int,
	@PeriodStart		datetime,
	@PeriodEnd			datetime,
	@EmployeeID			TIdentifier,
	@ProjectSelector	int,
	@ActiveProjectID	TIdentifier
AS
	SET NOCOUNT ON		

	DECLARE
		@CurrentEmployeeID TIdentifier,
		@ParameterValue sql_variant,
		@BillableHoursStyle int
		
	SET @CurrentEmployeeID = ISNULL(@EmployeeID, dbo.adfGetCurrentEmployeeID())

--	    
	EXEC 
		pjm6TimeEntryApproveBrowseParameters 
			@DateSelector, 
			@PeriodStart	OUTPUT,
			@PeriodEnd		OUTPUT

	EXEC dbo.[adfParameterGet] @Name='BillableHoursStyle', @Group='Pjm7', @Value=@ParameterValue OUTPUT
	SET @BillableHoursStyle = 
		CASE
			WHEN @ParameterValue IS NULL OR @ParameterValue = 0 THEN 0
			ELSE 1
		END

	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[AvailableProjects].[CustomerCompanyID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		CASE
			WHEN [AvailableProjects].[ViewFinance] = 1 OR
				[AvailableProjects].[ViewBillableHour]=1 OR
				(@BillableHoursStyle=1 AND [TimeEntry].[EmployeeID] = @CurrentEmployeeID)	
				THEN [TimeEntry].[BillableDuration]
			ELSE -60
		END AS BillableDuration,
		[TimeEntry].[Overtime],
		CASE
			WHEN [AvailableProjects].[ViewFinance] != 1  THEN -1 
			ELSE [TimeEntry].[Rate]
		END AS [Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE
			WHEN [AvailableProjects].[ViewFinance] != 1 THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[Project].[ProjectManagerEmployeeID],
		CASE
			WHEN [TimeEntry].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [TimeEntry].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [TimeEntry].[TaskID])
		END AS [DocumentName]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
		INNER JOIN
				dbo.fnPjm6GetAvailableProjectsForTimeEntryApproveBrowse (
				@ProjectSelector,
				@ActiveProjectID) as [AvailableProjects]
			ON [AvailableProjects].[ID] = [TimeEntry].[ProjectID]
	WHERE
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) 
			AND 
		(
			@DateSelector = 0 OR 
			(
				([TimeEntry].[StartTime] >= @PeriodStart)
				AND
				([TimeEntry].[StartTime] < @PeriodEnd)
			)
		)	AND
		(
			[TimeEntry].[State] = 2
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntryApproveBrowse] TO PUBLIC
GO
  