IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryGet'
		DROP PROCEDURE [dbo].[pjm5TimeEntryGet]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryGet'
GO

/******************************************************************************
**		File: pjm5TimeEntryGet.sql
**		Name: pjm5TimeEntryGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      26.03.09	ENB				   .
**									     
**									  ,  
**									 
**
**
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE
		@TimeEntryClass TClass,
		@RecurrencePatternID TIdentifier,
		@UserID TIdentifier
	
	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	SELECT @RecurrencePatternID = [RecurrencePatternID] FROM [Document] WHERE [Document].[Class] = @TimeEntryClass AND [Document].[ID] = @ID
	SET @UserID = dbo.adfGetCurrentUserID()

	DECLARE 
		@value TVariant,
		@FlagTask TBool,
		@FlagService TBool,
		@FlagFileAs TBool,
		@FlagComments TBool,
		@Separator1 TName,
		@Separator2 TName,
		@Separator3 TName,
		@TaskRequestSeparator TName,
		@ServiceRequestSeparator TName,
		@IssueSeparator TName,
		@FlagTaskRequest TBool,
		@FlagServiceRequest TBool,
		@FlagIssue TBool

	EXEC adfParameterGet @Name='DocumentLineSeparator1', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator1 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator2', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator2 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator3', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator3 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='TaskRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @TaskRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='ServiceRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @ServiceRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='IssueSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @IssueSeparator = CAST(@value as nvarchar(256))
	
	EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagTask = ISNULL(CAST(@value as bit), 0)
		
	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagService = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagComments = ISNULL(CAST(@value as bit), 0)
	
	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagIssue = ISNULL(CAST(@value as bit), 0)


	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		[TimeEntry].[BillableHour] * 60 AS [BillableDuration],
		[TimeEntry].[BillableHour],
		[TimeEntry].[Overtime],
		[TimeEntry].[Rate],
		dbo.fnPjm5GetEmployeeRate([TimeEntry].[EmployeeID], [TimeEntry].[ProjectID], 0,
			CASE [TimeEntry].[DocumentClass] WHEN dbo.adfGetClassByName('Pjm5.ServiceAssignment') THEN [TimeEntry].[DocumentID] ELSE NULL END, 1)
		AS [StandardRate],
		dbo.fnPjm5GetEmployeeRate([TimeEntry].[EmployeeID], [TimeEntry].[ProjectID], 1, 
			CASE [TimeEntry].[DocumentClass] WHEN dbo.adfGetClassByName('Pjm5.ServiceAssignment') THEN [TimeEntry].[DocumentID] ELSE NULL END, 1)
		AS [OvertimeRate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[Project].[RatesWithVAT],
		@RecurrencePatternID AS [RecurrencePatternID],
		[TimeEntry].[DocumentID],
		[TimeEntry].[DocumentClass],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([TimeEntry].[Class], 'ES', @UserID)) AS [ReminderInterval],
		dbo.fnPjm5GetEntryDescription(
			CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
			CASE @FlagService WHEN 1 THEN [ServiceAssignment].[FileAs] ELSE NULL END,
			CASE @FlagFileAs WHEN 1 THEN [TimeEntry].[FileAs] ELSE NULL END,
			CASE @FlagComments WHEN 1 THEN [TimeEntry].[Comments] ELSE NULL END,
			CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
			CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
			CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,
			ISNULL(@Separator1, ' '),
			ISNULL(@Separator2, ' '),
			ISNULL(@Separator3, ' '),
			ISNULL(@IssueSeparator, ' '),
			ISNULL(@ServiceRequestSeparator, ' '),
			ISNULL(@TaskRequestSeparator, ' '),
			[TimeEntry].[FileAs]
		) AS [Description],
		[TimeEntry].[MeetingRequestID],
		[TaskAssignment].[RemainingWork],
		[TaskAssignment].[RemainingOvertimeWork]
	FROM
		[vwTimeEntry] AS [TimeEntry]
		LEFT OUTER JOIN [Project]
			ON ([Project].[ID] = [TimeEntry].[ProjectID])
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [TimeEntry].[Class] AND
				[Reminder].[DocumentID] = [TimeEntry].[ID] AND
				[Reminder].[Subtype] = 'ES')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT OUTER JOIN [Task]
			ON [Task].[ID] = [TimeEntry].[TaskID]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID] AND
				[TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
		LEFT OUTER JOIN [ServiceRequest]
			ON [ServiceRequest].[Class] = [TimeEntry].[DocumentClass] 
				AND [ServiceRequest].[ID] = [TimeEntry].[DocumentID]
		LEFT OUTER JOIN [Issue]
			ON [Issue].[Class] = [TimeEntry].[DocumentClass] 
				AND [Issue].[ID] = [TimeEntry].[DocumentID]
		LEFT OUTER JOIN [TaskRequest]
			ON [TaskRequest].[Class] = [TimeEntry].[DocumentClass] 
				AND [TaskRequest].[ID] = [TimeEntry].[DocumentID]
		LEFT OUTER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[Class] = [TimeEntry].[DocumentClass] AND [ServiceAssignment].[ID] = [TimeEntry].[DocumentID]
	WHERE
		[TimeEntry].[ID] = @ID

	IF @@ROWCOUNT = 0
		RETURN 1
		
	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntryGet] TO PUBLIC
GO

 