﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7GetPeriodClosedDate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7GetPeriodClosedDate'
		DROP PROCEDURE [dbo].[pjm7GetPeriodClosedDate]
	END
GO

PRINT 'Creating procedure pjm7GetPeriodClosedDate'
GO
/******************************************************************************
**		File: 
**		Name: pjm7GetPeriodClosedDate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: DAL 
**		Date: 19.02.2015
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm7GetPeriodClosedDate
	@Result date OUTPUT
AS
BEGIN
	SET NOCOUNT ON

	DECLARE
		@PeriodeCloseDate TVariant

	EXEC adfParameterGet @Name='PeriodClosingDate', @Group='Pjm7', @Value = @PeriodeCloseDate OUTPUT
	
	IF @PeriodeCloseDate IS NOT NULL
	BEGIN		
		BEGIN TRY 
			SET @Result = CAST(@PeriodeCloseDate AS date)
		END TRY
		BEGIN CATCH
			SET @Result = NULL
		END CATCH
	END
	ELSE
	BEGIN
		SET @Result = NULL
	END
END
GO

GRANT EXEC ON pjm7GetPeriodClosedDate TO PUBLIC
GO
