IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'TimeEntrySimpleGet')
	BEGIN
		PRINT 'Dropping Procedure TimeEntrySimpleGet'
		DROP  Procedure  TimeEntrySimpleGet
	END

GO

PRINT 'Creating Procedure TimeEntrySimpleGet'
GO
/******************************************************************************
**		File: 
**		Name: TimeEntrySimpleGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure TimeEntrySimpleGet
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[FileAs],
		[TimeEntry].[StartTime],
		DATEADD(minute, [TimeEntry].[Duration], [TimeEntry].[StartTime]) as [EndTime],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[ProjectID],
		[Project].[Number] as [ProjectCode],
		[TimeEntry].[TaskID],
		[Task].[FileAs] as [TaskName],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[Billable],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[Class].[Guid]
	FROM
		[TimeEntry] INNER JOIN [Class]
			ON ([TimeEntry].[Class] = [Class].[Class])
		INNER JOIN [Project]
			ON [TimeEntry].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [Task]
			ON [TimeEntry].[TaskID] = [Task].[ID]
	WHERE
		[TimeEntry].[ID] = @ID
	RETURN 0
GO

GRANT EXEC ON TimeEntrySimpleGet TO PUBLIC
GO
  